// Automatically generated file. DO NOT EDIT.
// Generated by gen-device-svd.go from e310x.svd, see https://github.com/posborne/cmsis-svd/tree/master/data/SiFive-Community

//go:build sifive && fe310
// +build sifive,fe310

//
//

package sifive

import (
	"runtime/volatile"
	"unsafe"
)

// Some information about this device.
const (
	DEVICE = "FE310"
)

// Interrupt numbers.
const (
	IRQ_WATCHDOG = 1  // Watchdog
	IRQ_RTC      = 2  // Watchdog
	IRQ_UART0    = 3  // Universal Asynchronous Receiver Transmitter
	IRQ_UART1    = 4  //
	IRQ_QSPI0    = 5  // Quad Serial Peripheral Interface
	IRQ_QSPI1    = 6  //
	IRQ_QSPI2    = 7  //
	IRQ_GPIO0    = 8  // General Purpose Input Output
	IRQ_GPIO1    = 9  // General Purpose Input Output
	IRQ_GPIO2    = 10 // General Purpose Input Output
	IRQ_GPIO3    = 11 // General Purpose Input Output
	IRQ_GPIO4    = 12 // General Purpose Input Output
	IRQ_GPIO5    = 13 // General Purpose Input Output
	IRQ_GPIO6    = 14 // General Purpose Input Output
	IRQ_GPIO7    = 15 // General Purpose Input Output
	IRQ_GPIO8    = 16 // General Purpose Input Output
	IRQ_GPIO9    = 17 // General Purpose Input Output
	IRQ_GPIO10   = 18 // General Purpose Input Output
	IRQ_GPIO11   = 19 // General Purpose Input Output
	IRQ_GPIO12   = 20 // General Purpose Input Output
	IRQ_GPIO13   = 21 // General Purpose Input Output
	IRQ_GPIO14   = 22 // General Purpose Input Output
	IRQ_GPIO15   = 23 // General Purpose Input Output
	IRQ_GPIO16   = 24 // General Purpose Input Output
	IRQ_GPIO17   = 25 // General Purpose Input Output
	IRQ_GPIO18   = 26 // General Purpose Input Output
	IRQ_GPIO19   = 27 // General Purpose Input Output
	IRQ_GPIO20   = 28 // General Purpose Input Output
	IRQ_GPIO21   = 29 // General Purpose Input Output
	IRQ_GPIO22   = 30 // General Purpose Input Output
	IRQ_GPIO23   = 31 // General Purpose Input Output
	IRQ_GPIO24   = 32 // General Purpose Input Output
	IRQ_GPIO25   = 33 // General Purpose Input Output
	IRQ_GPIO26   = 34 // General Purpose Input Output
	IRQ_GPIO27   = 35 // General Purpose Input Output
	IRQ_GPIO28   = 36 // General Purpose Input Output
	IRQ_GPIO29   = 37 // General Purpose Input Output
	IRQ_GPIO30   = 38 // General Purpose Input Output
	IRQ_GPIO31   = 39 // General Purpose Input Output
	IRQ_PWM0CMP0 = 40 // 8-bit timer with 4 cmp
	IRQ_PWM0CMP1 = 41 // 8-bit timer with 4 cmp
	IRQ_PWM0CMP2 = 42 // 8-bit timer with 4 cmp
	IRQ_PWM0CMP3 = 43 // 8-bit timer with 4 cmp
	IRQ_PWM1CMP0 = 44 //
	IRQ_PWM1CMP1 = 45 //
	IRQ_PWM1CMP2 = 46 //
	IRQ_PWM1CMP3 = 47 //
	IRQ_PWM2CMP0 = 48 //
	IRQ_PWM2CMP1 = 49 //
	IRQ_PWM2CMP2 = 50 //
	IRQ_PWM2CMP3 = 51 //
	IRQ_I2C0     = 52 // Inter-Integrated Circuit Master Interface (FE310-G002 only)
	IRQ_max      = 52 // Highest interrupt number on this device.
)

// Peripherals.
var (
	CLINT  = (*CLINT_Type)(unsafe.Pointer(uintptr(0x2000000)))     // Coreplex Local Interrupts
	PLIC   = (*PLIC_Type)(unsafe.Pointer(uintptr(0xc000000)))      // Platform Level Interrupt Control
	WDOG   = (*Watchdog_Type)(unsafe.Pointer(uintptr(0x10000000))) // Watchdog
	RTC    = (*RTC_Type)(unsafe.Pointer(uintptr(0x10000000)))      // Watchdog
	AONCLK = (*AONCLOCK_Type)(unsafe.Pointer(uintptr(0x10000000))) // Always-On Clock Configuration
	BACKUP = (*BACKUP_Type)(unsafe.Pointer(uintptr(0x10000000)))   // Backup Registers
	PMU    = (*PMU_Type)(unsafe.Pointer(uintptr(0x10000000)))      // PMU
	PRCI   = (*PRCI_Type)(unsafe.Pointer(uintptr(0x10008000)))     // Power Reset Clock Interrupts
	OTP    = (*OTP_Type)(unsafe.Pointer(uintptr(0x10010000)))      // One Time Programmable Memory
	GPIO0  = (*GPIO_Type)(unsafe.Pointer(uintptr(0x10012000)))     // General Purpose Input Output
	UART0  = (*UART_Type)(unsafe.Pointer(uintptr(0x10013000)))     // Universal Asynchronous Receiver Transmitter
	QSPI0  = (*QSPI_Type)(unsafe.Pointer(uintptr(0x10014000)))     // Quad Serial Peripheral Interface
	PWM0   = (*PWM_Type)(unsafe.Pointer(uintptr(0x10015000)))      // 8-bit timer with 4 cmp
	I2C0   = (*I2C_Type)(unsafe.Pointer(uintptr(0x10016000)))      // Inter-Integrated Circuit Master Interface (FE310-G002 only)
	UART1  = (*UART_Type)(unsafe.Pointer(uintptr(0x10023000)))     // Universal Asynchronous Receiver Transmitter
	QSPI1  = (*QSPI_Type)(unsafe.Pointer(uintptr(0x10024000)))     // Quad Serial Peripheral Interface
	PWM1   = (*PWM_Type)(unsafe.Pointer(uintptr(0x10025000)))      // 8-bit timer with 4 cmp
	QSPI2  = (*QSPI_Type)(unsafe.Pointer(uintptr(0x10034000)))     // Quad Serial Peripheral Interface
	PWM2   = (*PWM_Type)(unsafe.Pointer(uintptr(0x10035000)))      // 8-bit timer with 4 cmp
)

// Coreplex Local Interrupts
type CLINT_Type struct {
	MSIP      volatile.Register32 // 0x0
	_         [16380]byte
	MTIMECMP  volatile.Register32 // 0x4000
	MTIMECMPH volatile.Register32 // 0x4004
	_         [32752]byte
	MTIME     volatile.Register32 // 0xBFF8
	MTIMEH    volatile.Register32 // 0xBFFC
}

// Platform Level Interrupt Control
type PLIC_Type struct {
	PRIORITY  [52]volatile.Register32 // 0x0
	_         [3888]byte
	PENDING   [2]volatile.Register32 // 0x1000
	_         [4088]byte
	ENABLE    [2]volatile.Register32 // 0x2000
	_         [2088952]byte
	THRESHOLD volatile.Register32 // 0x200000
	CLAIM     volatile.Register32 // 0x200004
}

// Watchdog
type Watchdog_Type struct {
	WDOGCFG   volatile.Register32 // 0x0
	_         [4]byte
	WDOGCOUNT volatile.Register32 // 0x8
	_         [4]byte
	WDOGS     volatile.Register32 // 0x10
	_         [4]byte
	WDOGFEED  volatile.Register32 // 0x18
	WDOGKEY   volatile.Register32 // 0x1C
	WDOGCMP   volatile.Register32 // 0x20
}

// Watchdog
type RTC_Type struct {
	_      [64]byte
	RTCCFG volatile.Register32 // 0x40
	_      [4]byte
	RTCLO  volatile.Register32 // 0x48
	RTCHI  volatile.Register32 // 0x4C
	RTCS   volatile.Register32 // 0x50
	_      [12]byte
	RTCCMP volatile.Register32 // 0x60
}

// Always-On Clock Configuration
type AONCLOCK_Type struct {
	_         [112]byte
	LFROSCCFG volatile.Register32 // 0x70
}

// Backup Registers
type BACKUP_Type struct {
	_      [128]byte
	BACKUP [16]volatile.Register32 // 0x80
}

// PMU
type PMU_Type struct {
	_          [256]byte
	PMUWAKEPM  [8]volatile.Register32 // 0x100
	PMUSLEEPPM [8]volatile.Register32 // 0x120
	PMUIE      volatile.Register32    // 0x140
	PMUCAUSE   volatile.Register32    // 0x144
	PMUSLEEP   volatile.Register32    // 0x148
	PMUKEY     volatile.Register32    // 0x14C
}

// Power Reset Clock Interrupts
type PRCI_Type struct {
	HFROSCCFG  volatile.Register32 // 0x0
	HFXOSCCFG  volatile.Register32 // 0x4
	PLLCFG     volatile.Register32 // 0x8
	PLLOUTDIV  volatile.Register32 // 0xC
	CORECLKCFG volatile.Register32 // 0x10
}

// One Time Programmable Memory
type OTP_Type struct {
	LOCK      volatile.Register32 // 0x0
	CLOCK     volatile.Register32 // 0x4
	OUTPUT_EN volatile.Register32 // 0x8
	SELECT    volatile.Register32 // 0xC
	WRITE_EN  volatile.Register32 // 0x10
	MODE      volatile.Register32 // 0x14
	MRR       volatile.Register32 // 0x18
	MPP       volatile.Register32 // 0x1C
	VRREN     volatile.Register32 // 0x20
	VPPEN     volatile.Register32 // 0x24
	ADDR      volatile.Register32 // 0x28
	DATA_IN   volatile.Register32 // 0x2C
	DATA_OUT  volatile.Register32 // 0x30
	RSCTRL    volatile.Register32 // 0x34
}

// General Purpose Input Output
type GPIO_Type struct {
	VALUE     volatile.Register32 // 0x0
	INPUT_EN  volatile.Register32 // 0x4
	OUTPUT_EN volatile.Register32 // 0x8
	PORT      volatile.Register32 // 0xC
	PULLUP    volatile.Register32 // 0x10
	DRIVE     volatile.Register32 // 0x14
	RISE_IE   volatile.Register32 // 0x18
	RISE_IP   volatile.Register32 // 0x1C
	FALL_IE   volatile.Register32 // 0x20
	FALL_IP   volatile.Register32 // 0x24
	HIGH_IE   volatile.Register32 // 0x28
	HIGH_IP   volatile.Register32 // 0x2C
	LOW_IE    volatile.Register32 // 0x30
	LOW_IP    volatile.Register32 // 0x34
	IOF_EN    volatile.Register32 // 0x38
	IOF_SEL   volatile.Register32 // 0x3C
	OUT_XOR   volatile.Register32 // 0x40
}

// Universal Asynchronous Receiver Transmitter
type UART_Type struct {
	TXDATA volatile.Register32 // 0x0
	RXDATA volatile.Register32 // 0x4
	TXCTRL volatile.Register32 // 0x8
	RXCTRL volatile.Register32 // 0xC
	IE     volatile.Register32 // 0x10
	IP     volatile.Register32 // 0x14
	DIV    volatile.Register32 // 0x18
}

// Quad Serial Peripheral Interface
type QSPI_Type struct {
	DIV    volatile.Register32 // 0x0
	MODE   volatile.Register32 // 0x4
	_      [8]byte
	CSID   volatile.Register32 // 0x10
	CSDEF  volatile.Register32 // 0x14
	CSMODE volatile.Register32 // 0x18
	_      [12]byte
	DELAY0 volatile.Register32 // 0x28
	DELAY1 volatile.Register32 // 0x2C
	_      [16]byte
	FMT    volatile.Register32 // 0x40
	_      [4]byte
	TXDATA volatile.Register32 // 0x48
	RXDATA volatile.Register32 // 0x4C
	TXMARK volatile.Register32 // 0x50
	RXMARK volatile.Register32 // 0x54
	_      [8]byte
	FCTRL  volatile.Register32 // 0x60
	FFMT   volatile.Register32 // 0x64
	_      [8]byte
	IE     volatile.Register32 // 0x70
	IP     volatile.Register32 // 0x74
}

// 8-bit timer with 4 cmp
type PWM_Type struct {
	CFG   volatile.Register32 // 0x0
	_     [4]byte
	COUNT volatile.Register32 // 0x8
	_     [4]byte
	PWMS  volatile.Register32 // 0x10
	_     [12]byte
	CMP0  volatile.Register32 // 0x20
	CMP1  volatile.Register32 // 0x24
	CMP2  volatile.Register32 // 0x28
	CMP3  volatile.Register32 // 0x2C
}

// Inter-Integrated Circuit Master Interface (FE310-G002 only)
type I2C_Type struct {
	PRER_LO volatile.Register32 // 0x0
	PRER_HI volatile.Register32 // 0x4
	CTR     volatile.Register32 // 0x8
	TXR_RXR volatile.Register32 // 0xC
	CR_SR   volatile.Register32 // 0x10
}

// Bitfields for CLINT: Coreplex Local Interrupts
const ()

// Bitfields for PLIC: Platform Level Interrupt Control
const (
	// THRESHOLD: Priority Threshold Register
	PLIC_THRESHOLD_PRIORITY_Pos   = 0x0 // Position of PRIORITY field.
	PLIC_THRESHOLD_PRIORITY_Msk   = 0x7 // Bit mask of PRIORITY field.
	PLIC_THRESHOLD_PRIORITY_Never = 0x0 // Never interrupt
	PLIC_THRESHOLD_PRIORITY_P1    = 0x1 // Priority 1
	PLIC_THRESHOLD_PRIORITY_P2    = 0x2 // Priority 2
	PLIC_THRESHOLD_PRIORITY_P3    = 0x3 // Priority 3
	PLIC_THRESHOLD_PRIORITY_P4    = 0x4 // Priority 4
	PLIC_THRESHOLD_PRIORITY_P5    = 0x5 // Priority 5
	PLIC_THRESHOLD_PRIORITY_P6    = 0x6 // Priority 6
	PLIC_THRESHOLD_PRIORITY_P7    = 0x7 // Priority 7
)

// Bitfields for WDOG: Watchdog
const (
	// WDOGCFG: Watchdog Configuration Register
	Watchdog_WDOGCFG_CMPIP_Pos       = 0x1c       // Position of CMPIP field.
	Watchdog_WDOGCFG_CMPIP_Msk       = 0x10000000 // Bit mask of CMPIP field.
	Watchdog_WDOGCFG_CMPIP           = 0x10000000 // Bit CMPIP.
	Watchdog_WDOGCFG_ENCOREAWAKE_Pos = 0xd        // Position of ENCOREAWAKE field.
	Watchdog_WDOGCFG_ENCOREAWAKE_Msk = 0x2000     // Bit mask of ENCOREAWAKE field.
	Watchdog_WDOGCFG_ENCOREAWAKE     = 0x2000     // Bit ENCOREAWAKE.
	Watchdog_WDOGCFG_ENALWAYS_Pos    = 0xc        // Position of ENALWAYS field.
	Watchdog_WDOGCFG_ENALWAYS_Msk    = 0x1000     // Bit mask of ENALWAYS field.
	Watchdog_WDOGCFG_ENALWAYS        = 0x1000     // Bit ENALWAYS.
	Watchdog_WDOGCFG_ZEROCMP_Pos     = 0x9        // Position of ZEROCMP field.
	Watchdog_WDOGCFG_ZEROCMP_Msk     = 0x200      // Bit mask of ZEROCMP field.
	Watchdog_WDOGCFG_ZEROCMP         = 0x200      // Bit ZEROCMP.
	Watchdog_WDOGCFG_RSTEN_Pos       = 0x8        // Position of RSTEN field.
	Watchdog_WDOGCFG_RSTEN_Msk       = 0x100      // Bit mask of RSTEN field.
	Watchdog_WDOGCFG_RSTEN           = 0x100      // Bit RSTEN.
	Watchdog_WDOGCFG_SCALE_Pos       = 0x0        // Position of SCALE field.
	Watchdog_WDOGCFG_SCALE_Msk       = 0xf        // Bit mask of SCALE field.

	// WDOGCMP: Watchdog Compare Register
	Watchdog_WDOGCMP_VALUE_Pos = 0x0    // Position of VALUE field.
	Watchdog_WDOGCMP_VALUE_Msk = 0xffff // Bit mask of VALUE field.
)

// Bitfields for RTC: Watchdog
const (
	// RTCCFG: RTC Configuration Register
	RTC_RTCCFG_CMPIP_Pos    = 0x1c       // Position of CMPIP field.
	RTC_RTCCFG_CMPIP_Msk    = 0x10000000 // Bit mask of CMPIP field.
	RTC_RTCCFG_CMPIP        = 0x10000000 // Bit CMPIP.
	RTC_RTCCFG_ENALWAYS_Pos = 0xc        // Position of ENALWAYS field.
	RTC_RTCCFG_ENALWAYS_Msk = 0x1000     // Bit mask of ENALWAYS field.
	RTC_RTCCFG_ENALWAYS     = 0x1000     // Bit ENALWAYS.
	RTC_RTCCFG_SCALE_Pos    = 0x0        // Position of SCALE field.
	RTC_RTCCFG_SCALE_Msk    = 0xf        // Bit mask of SCALE field.

	// RTCHI: RTC Counter High Register
	RTC_RTCHI_VALUE_Pos = 0x0    // Position of VALUE field.
	RTC_RTCHI_VALUE_Msk = 0xffff // Bit mask of VALUE field.
)

// Bitfields for AONCLK: Always-On Clock Configuration
const (
	// LFROSCCFG: AON Clock Configuration Register
	AONCLOCK_LFROSCCFG_READY_Pos  = 0x1f       // Position of READY field.
	AONCLOCK_LFROSCCFG_READY_Msk  = 0x80000000 // Bit mask of READY field.
	AONCLOCK_LFROSCCFG_READY      = 0x80000000 // Bit READY.
	AONCLOCK_LFROSCCFG_ENABLE_Pos = 0x1e       // Position of ENABLE field.
	AONCLOCK_LFROSCCFG_ENABLE_Msk = 0x40000000 // Bit mask of ENABLE field.
	AONCLOCK_LFROSCCFG_ENABLE     = 0x40000000 // Bit ENABLE.
	AONCLOCK_LFROSCCFG_TRIM_Pos   = 0x10       // Position of TRIM field.
	AONCLOCK_LFROSCCFG_TRIM_Msk   = 0x1f0000   // Bit mask of TRIM field.
	AONCLOCK_LFROSCCFG_DIV_Pos    = 0x0        // Position of DIV field.
	AONCLOCK_LFROSCCFG_DIV_Msk    = 0x3f       // Bit mask of DIV field.
)

// Bitfields for BACKUP: Backup Registers
const ()

// Bitfields for PMU: PMU
const (
	// PMUWAKEPM: PMU Wake Program Memory
	PMU_PMUWAKEPM_ISOLATE_Pos      = 0x9   // Position of ISOLATE field.
	PMU_PMUWAKEPM_ISOLATE_Msk      = 0x200 // Bit mask of ISOLATE field.
	PMU_PMUWAKEPM_ISOLATE          = 0x200 // Bit ISOLATE.
	PMU_PMUWAKEPM_HFCLKRST_Pos     = 0x8   // Position of HFCLKRST field.
	PMU_PMUWAKEPM_HFCLKRST_Msk     = 0x100 // Bit mask of HFCLKRST field.
	PMU_PMUWAKEPM_HFCLKRST         = 0x100 // Bit HFCLKRST.
	PMU_PMUWAKEPM_CORERST_Pos      = 0x7   // Position of CORERST field.
	PMU_PMUWAKEPM_CORERST_Msk      = 0x80  // Bit mask of CORERST field.
	PMU_PMUWAKEPM_CORERST          = 0x80  // Bit CORERST.
	PMU_PMUWAKEPM_PMU_OUT_1_EN_Pos = 0x5   // Position of PMU_OUT_1_EN field.
	PMU_PMUWAKEPM_PMU_OUT_1_EN_Msk = 0x20  // Bit mask of PMU_OUT_1_EN field.
	PMU_PMUWAKEPM_PMU_OUT_1_EN     = 0x20  // Bit PMU_OUT_1_EN.
	PMU_PMUWAKEPM_PMU_OUT_0_EN_Pos = 0x4   // Position of PMU_OUT_0_EN field.
	PMU_PMUWAKEPM_PMU_OUT_0_EN_Msk = 0x10  // Bit mask of PMU_OUT_0_EN field.
	PMU_PMUWAKEPM_PMU_OUT_0_EN     = 0x10  // Bit PMU_OUT_0_EN.
	PMU_PMUWAKEPM_DELAY_Pos        = 0x0   // Position of DELAY field.
	PMU_PMUWAKEPM_DELAY_Msk        = 0xf   // Bit mask of DELAY field.

	// PMUSLEEPPM: PMU Sleep Program Memory
	PMU_PMUSLEEPPM_ISOLATE_Pos      = 0x9   // Position of ISOLATE field.
	PMU_PMUSLEEPPM_ISOLATE_Msk      = 0x200 // Bit mask of ISOLATE field.
	PMU_PMUSLEEPPM_ISOLATE          = 0x200 // Bit ISOLATE.
	PMU_PMUSLEEPPM_HFCLKRST_Pos     = 0x8   // Position of HFCLKRST field.
	PMU_PMUSLEEPPM_HFCLKRST_Msk     = 0x100 // Bit mask of HFCLKRST field.
	PMU_PMUSLEEPPM_HFCLKRST         = 0x100 // Bit HFCLKRST.
	PMU_PMUSLEEPPM_CORERST_Pos      = 0x7   // Position of CORERST field.
	PMU_PMUSLEEPPM_CORERST_Msk      = 0x80  // Bit mask of CORERST field.
	PMU_PMUSLEEPPM_CORERST          = 0x80  // Bit CORERST.
	PMU_PMUSLEEPPM_PMU_OUT_1_EN_Pos = 0x5   // Position of PMU_OUT_1_EN field.
	PMU_PMUSLEEPPM_PMU_OUT_1_EN_Msk = 0x20  // Bit mask of PMU_OUT_1_EN field.
	PMU_PMUSLEEPPM_PMU_OUT_1_EN     = 0x20  // Bit PMU_OUT_1_EN.
	PMU_PMUSLEEPPM_PMU_OUT_0_EN_Pos = 0x4   // Position of PMU_OUT_0_EN field.
	PMU_PMUSLEEPPM_PMU_OUT_0_EN_Msk = 0x10  // Bit mask of PMU_OUT_0_EN field.
	PMU_PMUSLEEPPM_PMU_OUT_0_EN     = 0x10  // Bit PMU_OUT_0_EN.
	PMU_PMUSLEEPPM_DELAY_Pos        = 0x0   // Position of DELAY field.
	PMU_PMUSLEEPPM_DELAY_Msk        = 0xf   // Bit mask of DELAY field.

	// PMUIE: PMU Interrupt Enable Register
	PMU_PMUIE_AWAKEUP_Pos = 0x3 // Position of AWAKEUP field.
	PMU_PMUIE_AWAKEUP_Msk = 0x8 // Bit mask of AWAKEUP field.
	PMU_PMUIE_AWAKEUP     = 0x8 // Bit AWAKEUP.
	PMU_PMUIE_DWAKEUP_Pos = 0x2 // Position of DWAKEUP field.
	PMU_PMUIE_DWAKEUP_Msk = 0x4 // Bit mask of DWAKEUP field.
	PMU_PMUIE_DWAKEUP     = 0x4 // Bit DWAKEUP.
	PMU_PMUIE_RTC_Pos     = 0x1 // Position of RTC field.
	PMU_PMUIE_RTC_Msk     = 0x2 // Bit mask of RTC field.
	PMU_PMUIE_RTC         = 0x2 // Bit RTC.

	// PMUCAUSE: PMU Cause Register
	PMU_PMUCAUSE_RESETCAUSE_Pos      = 0x8   // Position of RESETCAUSE field.
	PMU_PMUCAUSE_RESETCAUSE_Msk      = 0x300 // Bit mask of RESETCAUSE field.
	PMU_PMUCAUSE_RESETCAUSE_PowerOn  = 0x0   // Power-on reset
	PMU_PMUCAUSE_RESETCAUSE_External = 0x1   // External reset
	PMU_PMUCAUSE_RESETCAUSE_Watchdog = 0x2   // Watchdog reset
	PMU_PMUCAUSE_WAKEUPCAUSE_Pos     = 0x0   // Position of WAKEUPCAUSE field.
	PMU_PMUCAUSE_WAKEUPCAUSE_Msk     = 0x3   // Bit mask of WAKEUPCAUSE field.
	PMU_PMUCAUSE_WAKEUPCAUSE_Reset   = 0x0   // Reset wakeup
	PMU_PMUCAUSE_WAKEUPCAUSE_RTC     = 0x1   // RTC wakeup
	PMU_PMUCAUSE_WAKEUPCAUSE_Digital = 0x2   // Digital input wakeup

	// PMUSLEEP: PMU Sleep Register
	PMU_PMUSLEEP_SLEEP_Pos = 0x0 // Position of SLEEP field.
	PMU_PMUSLEEP_SLEEP_Msk = 0x1 // Bit mask of SLEEP field.
	PMU_PMUSLEEP_SLEEP     = 0x1 // Bit SLEEP.
)

// Bitfields for PRCI: Power Reset Clock Interrupts
const (
	// HFROSCCFG: Clock Configuration Register
	PRCI_HFROSCCFG_READY_Pos  = 0x1f       // Position of READY field.
	PRCI_HFROSCCFG_READY_Msk  = 0x80000000 // Bit mask of READY field.
	PRCI_HFROSCCFG_READY      = 0x80000000 // Bit READY.
	PRCI_HFROSCCFG_ENABLE_Pos = 0x1e       // Position of ENABLE field.
	PRCI_HFROSCCFG_ENABLE_Msk = 0x40000000 // Bit mask of ENABLE field.
	PRCI_HFROSCCFG_ENABLE     = 0x40000000 // Bit ENABLE.
	PRCI_HFROSCCFG_TRIM_Pos   = 0x10       // Position of TRIM field.
	PRCI_HFROSCCFG_TRIM_Msk   = 0x1f0000   // Bit mask of TRIM field.
	PRCI_HFROSCCFG_DIV_Pos    = 0x0        // Position of DIV field.
	PRCI_HFROSCCFG_DIV_Msk    = 0x3f       // Bit mask of DIV field.

	// HFXOSCCFG: Clock Configuration Register
	PRCI_HFXOSCCFG_READY_Pos  = 0x1f       // Position of READY field.
	PRCI_HFXOSCCFG_READY_Msk  = 0x80000000 // Bit mask of READY field.
	PRCI_HFXOSCCFG_READY      = 0x80000000 // Bit READY.
	PRCI_HFXOSCCFG_ENABLE_Pos = 0x1e       // Position of ENABLE field.
	PRCI_HFXOSCCFG_ENABLE_Msk = 0x40000000 // Bit mask of ENABLE field.
	PRCI_HFXOSCCFG_ENABLE     = 0x40000000 // Bit ENABLE.

	// PLLCFG: PLL Configuration Register
	PRCI_PLLCFG_LOCK_Pos   = 0x1f       // Position of LOCK field.
	PRCI_PLLCFG_LOCK_Msk   = 0x80000000 // Bit mask of LOCK field.
	PRCI_PLLCFG_LOCK       = 0x80000000 // Bit LOCK.
	PRCI_PLLCFG_BYPASS_Pos = 0x12       // Position of BYPASS field.
	PRCI_PLLCFG_BYPASS_Msk = 0x40000    // Bit mask of BYPASS field.
	PRCI_PLLCFG_BYPASS     = 0x40000    // Bit BYPASS.
	PRCI_PLLCFG_REFSEL_Pos = 0x11       // Position of REFSEL field.
	PRCI_PLLCFG_REFSEL_Msk = 0x20000    // Bit mask of REFSEL field.
	PRCI_PLLCFG_REFSEL     = 0x20000    // Bit REFSEL.
	PRCI_PLLCFG_SEL_Pos    = 0x10       // Position of SEL field.
	PRCI_PLLCFG_SEL_Msk    = 0x10000    // Bit mask of SEL field.
	PRCI_PLLCFG_SEL        = 0x10000    // Bit SEL.
	PRCI_PLLCFG_PLLQ_Pos   = 0xa        // Position of PLLQ field.
	PRCI_PLLCFG_PLLQ_Msk   = 0xc00      // Bit mask of PLLQ field.
	PRCI_PLLCFG_PLLQ_Q2    = 0x1
	PRCI_PLLCFG_PLLQ_Q4    = 0x2
	PRCI_PLLCFG_PLLQ_Q8    = 0x3
	PRCI_PLLCFG_PLLF_Pos   = 0x4   // Position of PLLF field.
	PRCI_PLLCFG_PLLF_Msk   = 0x3f0 // Bit mask of PLLF field.
	PRCI_PLLCFG_PLLR_Pos   = 0x0   // Position of PLLR field.
	PRCI_PLLCFG_PLLR_Msk   = 0x7   // Bit mask of PLLR field.
	PRCI_PLLCFG_PLLR_R1    = 0x0
	PRCI_PLLCFG_PLLR_R2    = 0x1
	PRCI_PLLCFG_PLLR_R3    = 0x2
	PRCI_PLLCFG_PLLR_R4    = 0x3

	// PLLOUTDIV: PLL Divider Register
	PRCI_PLLOUTDIV_DIVBY1_Pos = 0x8   // Position of DIVBY1 field.
	PRCI_PLLOUTDIV_DIVBY1_Msk = 0x100 // Bit mask of DIVBY1 field.
	PRCI_PLLOUTDIV_DIVBY1     = 0x100 // Bit DIVBY1.
	PRCI_PLLOUTDIV_DIV_Pos    = 0x0   // Position of DIV field.
	PRCI_PLLOUTDIV_DIV_Msk    = 0x3f  // Bit mask of DIV field.
)

// Bitfields for OTP: One Time Programmable Memory
const ()

// Bitfields for GPIO0: General Purpose Input Output
const (
	// VALUE: Pin value.
	GPIO_VALUE_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_VALUE_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_VALUE_PIN0      = 0x1        // Bit PIN0.
	GPIO_VALUE_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_VALUE_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_VALUE_PIN1      = 0x2        // Bit PIN1.
	GPIO_VALUE_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_VALUE_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_VALUE_PIN2      = 0x4        // Bit PIN2.
	GPIO_VALUE_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_VALUE_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_VALUE_PIN3      = 0x8        // Bit PIN3.
	GPIO_VALUE_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_VALUE_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_VALUE_PIN4      = 0x10       // Bit PIN4.
	GPIO_VALUE_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_VALUE_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_VALUE_PIN5      = 0x20       // Bit PIN5.
	GPIO_VALUE_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_VALUE_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_VALUE_PIN6      = 0x40       // Bit PIN6.
	GPIO_VALUE_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_VALUE_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_VALUE_PIN7      = 0x80       // Bit PIN7.
	GPIO_VALUE_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_VALUE_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_VALUE_PIN8      = 0x100      // Bit PIN8.
	GPIO_VALUE_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_VALUE_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_VALUE_PIN9      = 0x200      // Bit PIN9.
	GPIO_VALUE_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_VALUE_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_VALUE_PIN10     = 0x400      // Bit PIN10.
	GPIO_VALUE_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_VALUE_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_VALUE_PIN11     = 0x800      // Bit PIN11.
	GPIO_VALUE_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_VALUE_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_VALUE_PIN12     = 0x1000     // Bit PIN12.
	GPIO_VALUE_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_VALUE_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_VALUE_PIN13     = 0x2000     // Bit PIN13.
	GPIO_VALUE_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_VALUE_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_VALUE_PIN14     = 0x4000     // Bit PIN14.
	GPIO_VALUE_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_VALUE_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_VALUE_PIN15     = 0x8000     // Bit PIN15.
	GPIO_VALUE_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_VALUE_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_VALUE_PIN16     = 0x10000    // Bit PIN16.
	GPIO_VALUE_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_VALUE_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_VALUE_PIN17     = 0x20000    // Bit PIN17.
	GPIO_VALUE_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_VALUE_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_VALUE_PIN18     = 0x40000    // Bit PIN18.
	GPIO_VALUE_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_VALUE_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_VALUE_PIN19     = 0x80000    // Bit PIN19.
	GPIO_VALUE_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_VALUE_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_VALUE_PIN20     = 0x100000   // Bit PIN20.
	GPIO_VALUE_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_VALUE_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_VALUE_PIN21     = 0x200000   // Bit PIN21.
	GPIO_VALUE_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_VALUE_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_VALUE_PIN22     = 0x400000   // Bit PIN22.
	GPIO_VALUE_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_VALUE_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_VALUE_PIN23     = 0x800000   // Bit PIN23.
	GPIO_VALUE_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_VALUE_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_VALUE_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_VALUE_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_VALUE_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_VALUE_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_VALUE_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_VALUE_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_VALUE_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_VALUE_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_VALUE_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_VALUE_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_VALUE_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_VALUE_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_VALUE_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_VALUE_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_VALUE_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_VALUE_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_VALUE_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_VALUE_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_VALUE_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_VALUE_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_VALUE_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_VALUE_PIN31     = 0x80000000 // Bit PIN31.

	// INPUT_EN: Pin Input Enable Register
	GPIO_INPUT_EN_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_INPUT_EN_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_INPUT_EN_PIN0      = 0x1        // Bit PIN0.
	GPIO_INPUT_EN_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_INPUT_EN_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_INPUT_EN_PIN1      = 0x2        // Bit PIN1.
	GPIO_INPUT_EN_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_INPUT_EN_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_INPUT_EN_PIN2      = 0x4        // Bit PIN2.
	GPIO_INPUT_EN_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_INPUT_EN_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_INPUT_EN_PIN3      = 0x8        // Bit PIN3.
	GPIO_INPUT_EN_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_INPUT_EN_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_INPUT_EN_PIN4      = 0x10       // Bit PIN4.
	GPIO_INPUT_EN_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_INPUT_EN_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_INPUT_EN_PIN5      = 0x20       // Bit PIN5.
	GPIO_INPUT_EN_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_INPUT_EN_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_INPUT_EN_PIN6      = 0x40       // Bit PIN6.
	GPIO_INPUT_EN_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_INPUT_EN_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_INPUT_EN_PIN7      = 0x80       // Bit PIN7.
	GPIO_INPUT_EN_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_INPUT_EN_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_INPUT_EN_PIN8      = 0x100      // Bit PIN8.
	GPIO_INPUT_EN_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_INPUT_EN_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_INPUT_EN_PIN9      = 0x200      // Bit PIN9.
	GPIO_INPUT_EN_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_INPUT_EN_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_INPUT_EN_PIN10     = 0x400      // Bit PIN10.
	GPIO_INPUT_EN_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_INPUT_EN_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_INPUT_EN_PIN11     = 0x800      // Bit PIN11.
	GPIO_INPUT_EN_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_INPUT_EN_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_INPUT_EN_PIN12     = 0x1000     // Bit PIN12.
	GPIO_INPUT_EN_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_INPUT_EN_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_INPUT_EN_PIN13     = 0x2000     // Bit PIN13.
	GPIO_INPUT_EN_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_INPUT_EN_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_INPUT_EN_PIN14     = 0x4000     // Bit PIN14.
	GPIO_INPUT_EN_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_INPUT_EN_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_INPUT_EN_PIN15     = 0x8000     // Bit PIN15.
	GPIO_INPUT_EN_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_INPUT_EN_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_INPUT_EN_PIN16     = 0x10000    // Bit PIN16.
	GPIO_INPUT_EN_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_INPUT_EN_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_INPUT_EN_PIN17     = 0x20000    // Bit PIN17.
	GPIO_INPUT_EN_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_INPUT_EN_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_INPUT_EN_PIN18     = 0x40000    // Bit PIN18.
	GPIO_INPUT_EN_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_INPUT_EN_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_INPUT_EN_PIN19     = 0x80000    // Bit PIN19.
	GPIO_INPUT_EN_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_INPUT_EN_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_INPUT_EN_PIN20     = 0x100000   // Bit PIN20.
	GPIO_INPUT_EN_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_INPUT_EN_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_INPUT_EN_PIN21     = 0x200000   // Bit PIN21.
	GPIO_INPUT_EN_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_INPUT_EN_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_INPUT_EN_PIN22     = 0x400000   // Bit PIN22.
	GPIO_INPUT_EN_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_INPUT_EN_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_INPUT_EN_PIN23     = 0x800000   // Bit PIN23.
	GPIO_INPUT_EN_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_INPUT_EN_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_INPUT_EN_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_INPUT_EN_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_INPUT_EN_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_INPUT_EN_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_INPUT_EN_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_INPUT_EN_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_INPUT_EN_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_INPUT_EN_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_INPUT_EN_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_INPUT_EN_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_INPUT_EN_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_INPUT_EN_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_INPUT_EN_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_INPUT_EN_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_INPUT_EN_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_INPUT_EN_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_INPUT_EN_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_INPUT_EN_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_INPUT_EN_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_INPUT_EN_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_INPUT_EN_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_INPUT_EN_PIN31     = 0x80000000 // Bit PIN31.

	// OUTPUT_EN: Pin Output Enable Register
	GPIO_OUTPUT_EN_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_OUTPUT_EN_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_OUTPUT_EN_PIN0      = 0x1        // Bit PIN0.
	GPIO_OUTPUT_EN_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_OUTPUT_EN_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_OUTPUT_EN_PIN1      = 0x2        // Bit PIN1.
	GPIO_OUTPUT_EN_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_OUTPUT_EN_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_OUTPUT_EN_PIN2      = 0x4        // Bit PIN2.
	GPIO_OUTPUT_EN_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_OUTPUT_EN_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_OUTPUT_EN_PIN3      = 0x8        // Bit PIN3.
	GPIO_OUTPUT_EN_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_OUTPUT_EN_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_OUTPUT_EN_PIN4      = 0x10       // Bit PIN4.
	GPIO_OUTPUT_EN_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_OUTPUT_EN_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_OUTPUT_EN_PIN5      = 0x20       // Bit PIN5.
	GPIO_OUTPUT_EN_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_OUTPUT_EN_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_OUTPUT_EN_PIN6      = 0x40       // Bit PIN6.
	GPIO_OUTPUT_EN_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_OUTPUT_EN_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_OUTPUT_EN_PIN7      = 0x80       // Bit PIN7.
	GPIO_OUTPUT_EN_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_OUTPUT_EN_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_OUTPUT_EN_PIN8      = 0x100      // Bit PIN8.
	GPIO_OUTPUT_EN_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_OUTPUT_EN_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_OUTPUT_EN_PIN9      = 0x200      // Bit PIN9.
	GPIO_OUTPUT_EN_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_OUTPUT_EN_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_OUTPUT_EN_PIN10     = 0x400      // Bit PIN10.
	GPIO_OUTPUT_EN_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_OUTPUT_EN_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_OUTPUT_EN_PIN11     = 0x800      // Bit PIN11.
	GPIO_OUTPUT_EN_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_OUTPUT_EN_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_OUTPUT_EN_PIN12     = 0x1000     // Bit PIN12.
	GPIO_OUTPUT_EN_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_OUTPUT_EN_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_OUTPUT_EN_PIN13     = 0x2000     // Bit PIN13.
	GPIO_OUTPUT_EN_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_OUTPUT_EN_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_OUTPUT_EN_PIN14     = 0x4000     // Bit PIN14.
	GPIO_OUTPUT_EN_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_OUTPUT_EN_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_OUTPUT_EN_PIN15     = 0x8000     // Bit PIN15.
	GPIO_OUTPUT_EN_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_OUTPUT_EN_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_OUTPUT_EN_PIN16     = 0x10000    // Bit PIN16.
	GPIO_OUTPUT_EN_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_OUTPUT_EN_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_OUTPUT_EN_PIN17     = 0x20000    // Bit PIN17.
	GPIO_OUTPUT_EN_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_OUTPUT_EN_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_OUTPUT_EN_PIN18     = 0x40000    // Bit PIN18.
	GPIO_OUTPUT_EN_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_OUTPUT_EN_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_OUTPUT_EN_PIN19     = 0x80000    // Bit PIN19.
	GPIO_OUTPUT_EN_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_OUTPUT_EN_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_OUTPUT_EN_PIN20     = 0x100000   // Bit PIN20.
	GPIO_OUTPUT_EN_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_OUTPUT_EN_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_OUTPUT_EN_PIN21     = 0x200000   // Bit PIN21.
	GPIO_OUTPUT_EN_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_OUTPUT_EN_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_OUTPUT_EN_PIN22     = 0x400000   // Bit PIN22.
	GPIO_OUTPUT_EN_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_OUTPUT_EN_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_OUTPUT_EN_PIN23     = 0x800000   // Bit PIN23.
	GPIO_OUTPUT_EN_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_OUTPUT_EN_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_OUTPUT_EN_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_OUTPUT_EN_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_OUTPUT_EN_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_OUTPUT_EN_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_OUTPUT_EN_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_OUTPUT_EN_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_OUTPUT_EN_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_OUTPUT_EN_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_OUTPUT_EN_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_OUTPUT_EN_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_OUTPUT_EN_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_OUTPUT_EN_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_OUTPUT_EN_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_OUTPUT_EN_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_OUTPUT_EN_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_OUTPUT_EN_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_OUTPUT_EN_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_OUTPUT_EN_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_OUTPUT_EN_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_OUTPUT_EN_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_OUTPUT_EN_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_OUTPUT_EN_PIN31     = 0x80000000 // Bit PIN31.

	// PORT: Output Port Value Register
	GPIO_PORT_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_PORT_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_PORT_PIN0      = 0x1        // Bit PIN0.
	GPIO_PORT_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_PORT_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_PORT_PIN1      = 0x2        // Bit PIN1.
	GPIO_PORT_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_PORT_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_PORT_PIN2      = 0x4        // Bit PIN2.
	GPIO_PORT_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_PORT_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_PORT_PIN3      = 0x8        // Bit PIN3.
	GPIO_PORT_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_PORT_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_PORT_PIN4      = 0x10       // Bit PIN4.
	GPIO_PORT_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_PORT_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_PORT_PIN5      = 0x20       // Bit PIN5.
	GPIO_PORT_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_PORT_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_PORT_PIN6      = 0x40       // Bit PIN6.
	GPIO_PORT_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_PORT_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_PORT_PIN7      = 0x80       // Bit PIN7.
	GPIO_PORT_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_PORT_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_PORT_PIN8      = 0x100      // Bit PIN8.
	GPIO_PORT_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_PORT_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_PORT_PIN9      = 0x200      // Bit PIN9.
	GPIO_PORT_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_PORT_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_PORT_PIN10     = 0x400      // Bit PIN10.
	GPIO_PORT_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_PORT_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_PORT_PIN11     = 0x800      // Bit PIN11.
	GPIO_PORT_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_PORT_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_PORT_PIN12     = 0x1000     // Bit PIN12.
	GPIO_PORT_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_PORT_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_PORT_PIN13     = 0x2000     // Bit PIN13.
	GPIO_PORT_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_PORT_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_PORT_PIN14     = 0x4000     // Bit PIN14.
	GPIO_PORT_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_PORT_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_PORT_PIN15     = 0x8000     // Bit PIN15.
	GPIO_PORT_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_PORT_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_PORT_PIN16     = 0x10000    // Bit PIN16.
	GPIO_PORT_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_PORT_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_PORT_PIN17     = 0x20000    // Bit PIN17.
	GPIO_PORT_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_PORT_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_PORT_PIN18     = 0x40000    // Bit PIN18.
	GPIO_PORT_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_PORT_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_PORT_PIN19     = 0x80000    // Bit PIN19.
	GPIO_PORT_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_PORT_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_PORT_PIN20     = 0x100000   // Bit PIN20.
	GPIO_PORT_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_PORT_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_PORT_PIN21     = 0x200000   // Bit PIN21.
	GPIO_PORT_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_PORT_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_PORT_PIN22     = 0x400000   // Bit PIN22.
	GPIO_PORT_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_PORT_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_PORT_PIN23     = 0x800000   // Bit PIN23.
	GPIO_PORT_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_PORT_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_PORT_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_PORT_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_PORT_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_PORT_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_PORT_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_PORT_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_PORT_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_PORT_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_PORT_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_PORT_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_PORT_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_PORT_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_PORT_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_PORT_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_PORT_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_PORT_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_PORT_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_PORT_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_PORT_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_PORT_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_PORT_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_PORT_PIN31     = 0x80000000 // Bit PIN31.

	// PULLUP: Internal Pull-Up Enable Register
	GPIO_PULLUP_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_PULLUP_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_PULLUP_PIN0      = 0x1        // Bit PIN0.
	GPIO_PULLUP_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_PULLUP_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_PULLUP_PIN1      = 0x2        // Bit PIN1.
	GPIO_PULLUP_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_PULLUP_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_PULLUP_PIN2      = 0x4        // Bit PIN2.
	GPIO_PULLUP_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_PULLUP_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_PULLUP_PIN3      = 0x8        // Bit PIN3.
	GPIO_PULLUP_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_PULLUP_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_PULLUP_PIN4      = 0x10       // Bit PIN4.
	GPIO_PULLUP_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_PULLUP_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_PULLUP_PIN5      = 0x20       // Bit PIN5.
	GPIO_PULLUP_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_PULLUP_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_PULLUP_PIN6      = 0x40       // Bit PIN6.
	GPIO_PULLUP_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_PULLUP_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_PULLUP_PIN7      = 0x80       // Bit PIN7.
	GPIO_PULLUP_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_PULLUP_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_PULLUP_PIN8      = 0x100      // Bit PIN8.
	GPIO_PULLUP_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_PULLUP_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_PULLUP_PIN9      = 0x200      // Bit PIN9.
	GPIO_PULLUP_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_PULLUP_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_PULLUP_PIN10     = 0x400      // Bit PIN10.
	GPIO_PULLUP_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_PULLUP_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_PULLUP_PIN11     = 0x800      // Bit PIN11.
	GPIO_PULLUP_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_PULLUP_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_PULLUP_PIN12     = 0x1000     // Bit PIN12.
	GPIO_PULLUP_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_PULLUP_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_PULLUP_PIN13     = 0x2000     // Bit PIN13.
	GPIO_PULLUP_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_PULLUP_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_PULLUP_PIN14     = 0x4000     // Bit PIN14.
	GPIO_PULLUP_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_PULLUP_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_PULLUP_PIN15     = 0x8000     // Bit PIN15.
	GPIO_PULLUP_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_PULLUP_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_PULLUP_PIN16     = 0x10000    // Bit PIN16.
	GPIO_PULLUP_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_PULLUP_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_PULLUP_PIN17     = 0x20000    // Bit PIN17.
	GPIO_PULLUP_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_PULLUP_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_PULLUP_PIN18     = 0x40000    // Bit PIN18.
	GPIO_PULLUP_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_PULLUP_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_PULLUP_PIN19     = 0x80000    // Bit PIN19.
	GPIO_PULLUP_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_PULLUP_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_PULLUP_PIN20     = 0x100000   // Bit PIN20.
	GPIO_PULLUP_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_PULLUP_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_PULLUP_PIN21     = 0x200000   // Bit PIN21.
	GPIO_PULLUP_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_PULLUP_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_PULLUP_PIN22     = 0x400000   // Bit PIN22.
	GPIO_PULLUP_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_PULLUP_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_PULLUP_PIN23     = 0x800000   // Bit PIN23.
	GPIO_PULLUP_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_PULLUP_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_PULLUP_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_PULLUP_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_PULLUP_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_PULLUP_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_PULLUP_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_PULLUP_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_PULLUP_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_PULLUP_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_PULLUP_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_PULLUP_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_PULLUP_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_PULLUP_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_PULLUP_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_PULLUP_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_PULLUP_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_PULLUP_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_PULLUP_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_PULLUP_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_PULLUP_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_PULLUP_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_PULLUP_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_PULLUP_PIN31     = 0x80000000 // Bit PIN31.

	// DRIVE: Drive Strength Register
	GPIO_DRIVE_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_DRIVE_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_DRIVE_PIN0      = 0x1        // Bit PIN0.
	GPIO_DRIVE_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_DRIVE_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_DRIVE_PIN1      = 0x2        // Bit PIN1.
	GPIO_DRIVE_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_DRIVE_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_DRIVE_PIN2      = 0x4        // Bit PIN2.
	GPIO_DRIVE_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_DRIVE_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_DRIVE_PIN3      = 0x8        // Bit PIN3.
	GPIO_DRIVE_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_DRIVE_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_DRIVE_PIN4      = 0x10       // Bit PIN4.
	GPIO_DRIVE_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_DRIVE_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_DRIVE_PIN5      = 0x20       // Bit PIN5.
	GPIO_DRIVE_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_DRIVE_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_DRIVE_PIN6      = 0x40       // Bit PIN6.
	GPIO_DRIVE_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_DRIVE_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_DRIVE_PIN7      = 0x80       // Bit PIN7.
	GPIO_DRIVE_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_DRIVE_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_DRIVE_PIN8      = 0x100      // Bit PIN8.
	GPIO_DRIVE_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_DRIVE_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_DRIVE_PIN9      = 0x200      // Bit PIN9.
	GPIO_DRIVE_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_DRIVE_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_DRIVE_PIN10     = 0x400      // Bit PIN10.
	GPIO_DRIVE_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_DRIVE_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_DRIVE_PIN11     = 0x800      // Bit PIN11.
	GPIO_DRIVE_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_DRIVE_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_DRIVE_PIN12     = 0x1000     // Bit PIN12.
	GPIO_DRIVE_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_DRIVE_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_DRIVE_PIN13     = 0x2000     // Bit PIN13.
	GPIO_DRIVE_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_DRIVE_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_DRIVE_PIN14     = 0x4000     // Bit PIN14.
	GPIO_DRIVE_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_DRIVE_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_DRIVE_PIN15     = 0x8000     // Bit PIN15.
	GPIO_DRIVE_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_DRIVE_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_DRIVE_PIN16     = 0x10000    // Bit PIN16.
	GPIO_DRIVE_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_DRIVE_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_DRIVE_PIN17     = 0x20000    // Bit PIN17.
	GPIO_DRIVE_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_DRIVE_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_DRIVE_PIN18     = 0x40000    // Bit PIN18.
	GPIO_DRIVE_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_DRIVE_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_DRIVE_PIN19     = 0x80000    // Bit PIN19.
	GPIO_DRIVE_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_DRIVE_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_DRIVE_PIN20     = 0x100000   // Bit PIN20.
	GPIO_DRIVE_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_DRIVE_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_DRIVE_PIN21     = 0x200000   // Bit PIN21.
	GPIO_DRIVE_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_DRIVE_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_DRIVE_PIN22     = 0x400000   // Bit PIN22.
	GPIO_DRIVE_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_DRIVE_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_DRIVE_PIN23     = 0x800000   // Bit PIN23.
	GPIO_DRIVE_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_DRIVE_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_DRIVE_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_DRIVE_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_DRIVE_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_DRIVE_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_DRIVE_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_DRIVE_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_DRIVE_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_DRIVE_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_DRIVE_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_DRIVE_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_DRIVE_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_DRIVE_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_DRIVE_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_DRIVE_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_DRIVE_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_DRIVE_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_DRIVE_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_DRIVE_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_DRIVE_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_DRIVE_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_DRIVE_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_DRIVE_PIN31     = 0x80000000 // Bit PIN31.

	// RISE_IE: Rise Interrupt Enable Register
	GPIO_RISE_IE_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_RISE_IE_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_RISE_IE_PIN0      = 0x1        // Bit PIN0.
	GPIO_RISE_IE_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_RISE_IE_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_RISE_IE_PIN1      = 0x2        // Bit PIN1.
	GPIO_RISE_IE_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_RISE_IE_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_RISE_IE_PIN2      = 0x4        // Bit PIN2.
	GPIO_RISE_IE_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_RISE_IE_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_RISE_IE_PIN3      = 0x8        // Bit PIN3.
	GPIO_RISE_IE_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_RISE_IE_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_RISE_IE_PIN4      = 0x10       // Bit PIN4.
	GPIO_RISE_IE_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_RISE_IE_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_RISE_IE_PIN5      = 0x20       // Bit PIN5.
	GPIO_RISE_IE_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_RISE_IE_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_RISE_IE_PIN6      = 0x40       // Bit PIN6.
	GPIO_RISE_IE_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_RISE_IE_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_RISE_IE_PIN7      = 0x80       // Bit PIN7.
	GPIO_RISE_IE_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_RISE_IE_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_RISE_IE_PIN8      = 0x100      // Bit PIN8.
	GPIO_RISE_IE_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_RISE_IE_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_RISE_IE_PIN9      = 0x200      // Bit PIN9.
	GPIO_RISE_IE_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_RISE_IE_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_RISE_IE_PIN10     = 0x400      // Bit PIN10.
	GPIO_RISE_IE_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_RISE_IE_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_RISE_IE_PIN11     = 0x800      // Bit PIN11.
	GPIO_RISE_IE_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_RISE_IE_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_RISE_IE_PIN12     = 0x1000     // Bit PIN12.
	GPIO_RISE_IE_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_RISE_IE_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_RISE_IE_PIN13     = 0x2000     // Bit PIN13.
	GPIO_RISE_IE_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_RISE_IE_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_RISE_IE_PIN14     = 0x4000     // Bit PIN14.
	GPIO_RISE_IE_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_RISE_IE_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_RISE_IE_PIN15     = 0x8000     // Bit PIN15.
	GPIO_RISE_IE_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_RISE_IE_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_RISE_IE_PIN16     = 0x10000    // Bit PIN16.
	GPIO_RISE_IE_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_RISE_IE_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_RISE_IE_PIN17     = 0x20000    // Bit PIN17.
	GPIO_RISE_IE_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_RISE_IE_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_RISE_IE_PIN18     = 0x40000    // Bit PIN18.
	GPIO_RISE_IE_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_RISE_IE_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_RISE_IE_PIN19     = 0x80000    // Bit PIN19.
	GPIO_RISE_IE_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_RISE_IE_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_RISE_IE_PIN20     = 0x100000   // Bit PIN20.
	GPIO_RISE_IE_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_RISE_IE_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_RISE_IE_PIN21     = 0x200000   // Bit PIN21.
	GPIO_RISE_IE_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_RISE_IE_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_RISE_IE_PIN22     = 0x400000   // Bit PIN22.
	GPIO_RISE_IE_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_RISE_IE_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_RISE_IE_PIN23     = 0x800000   // Bit PIN23.
	GPIO_RISE_IE_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_RISE_IE_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_RISE_IE_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_RISE_IE_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_RISE_IE_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_RISE_IE_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_RISE_IE_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_RISE_IE_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_RISE_IE_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_RISE_IE_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_RISE_IE_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_RISE_IE_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_RISE_IE_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_RISE_IE_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_RISE_IE_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_RISE_IE_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_RISE_IE_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_RISE_IE_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_RISE_IE_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_RISE_IE_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_RISE_IE_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_RISE_IE_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_RISE_IE_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_RISE_IE_PIN31     = 0x80000000 // Bit PIN31.

	// RISE_IP: Rise Interrupt Pending Register
	GPIO_RISE_IP_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_RISE_IP_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_RISE_IP_PIN0      = 0x1        // Bit PIN0.
	GPIO_RISE_IP_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_RISE_IP_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_RISE_IP_PIN1      = 0x2        // Bit PIN1.
	GPIO_RISE_IP_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_RISE_IP_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_RISE_IP_PIN2      = 0x4        // Bit PIN2.
	GPIO_RISE_IP_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_RISE_IP_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_RISE_IP_PIN3      = 0x8        // Bit PIN3.
	GPIO_RISE_IP_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_RISE_IP_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_RISE_IP_PIN4      = 0x10       // Bit PIN4.
	GPIO_RISE_IP_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_RISE_IP_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_RISE_IP_PIN5      = 0x20       // Bit PIN5.
	GPIO_RISE_IP_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_RISE_IP_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_RISE_IP_PIN6      = 0x40       // Bit PIN6.
	GPIO_RISE_IP_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_RISE_IP_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_RISE_IP_PIN7      = 0x80       // Bit PIN7.
	GPIO_RISE_IP_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_RISE_IP_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_RISE_IP_PIN8      = 0x100      // Bit PIN8.
	GPIO_RISE_IP_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_RISE_IP_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_RISE_IP_PIN9      = 0x200      // Bit PIN9.
	GPIO_RISE_IP_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_RISE_IP_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_RISE_IP_PIN10     = 0x400      // Bit PIN10.
	GPIO_RISE_IP_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_RISE_IP_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_RISE_IP_PIN11     = 0x800      // Bit PIN11.
	GPIO_RISE_IP_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_RISE_IP_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_RISE_IP_PIN12     = 0x1000     // Bit PIN12.
	GPIO_RISE_IP_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_RISE_IP_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_RISE_IP_PIN13     = 0x2000     // Bit PIN13.
	GPIO_RISE_IP_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_RISE_IP_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_RISE_IP_PIN14     = 0x4000     // Bit PIN14.
	GPIO_RISE_IP_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_RISE_IP_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_RISE_IP_PIN15     = 0x8000     // Bit PIN15.
	GPIO_RISE_IP_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_RISE_IP_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_RISE_IP_PIN16     = 0x10000    // Bit PIN16.
	GPIO_RISE_IP_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_RISE_IP_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_RISE_IP_PIN17     = 0x20000    // Bit PIN17.
	GPIO_RISE_IP_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_RISE_IP_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_RISE_IP_PIN18     = 0x40000    // Bit PIN18.
	GPIO_RISE_IP_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_RISE_IP_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_RISE_IP_PIN19     = 0x80000    // Bit PIN19.
	GPIO_RISE_IP_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_RISE_IP_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_RISE_IP_PIN20     = 0x100000   // Bit PIN20.
	GPIO_RISE_IP_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_RISE_IP_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_RISE_IP_PIN21     = 0x200000   // Bit PIN21.
	GPIO_RISE_IP_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_RISE_IP_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_RISE_IP_PIN22     = 0x400000   // Bit PIN22.
	GPIO_RISE_IP_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_RISE_IP_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_RISE_IP_PIN23     = 0x800000   // Bit PIN23.
	GPIO_RISE_IP_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_RISE_IP_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_RISE_IP_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_RISE_IP_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_RISE_IP_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_RISE_IP_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_RISE_IP_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_RISE_IP_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_RISE_IP_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_RISE_IP_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_RISE_IP_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_RISE_IP_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_RISE_IP_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_RISE_IP_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_RISE_IP_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_RISE_IP_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_RISE_IP_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_RISE_IP_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_RISE_IP_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_RISE_IP_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_RISE_IP_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_RISE_IP_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_RISE_IP_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_RISE_IP_PIN31     = 0x80000000 // Bit PIN31.

	// FALL_IE: Fall Interrupt Enable Register
	GPIO_FALL_IE_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_FALL_IE_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_FALL_IE_PIN0      = 0x1        // Bit PIN0.
	GPIO_FALL_IE_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_FALL_IE_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_FALL_IE_PIN1      = 0x2        // Bit PIN1.
	GPIO_FALL_IE_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_FALL_IE_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_FALL_IE_PIN2      = 0x4        // Bit PIN2.
	GPIO_FALL_IE_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_FALL_IE_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_FALL_IE_PIN3      = 0x8        // Bit PIN3.
	GPIO_FALL_IE_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_FALL_IE_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_FALL_IE_PIN4      = 0x10       // Bit PIN4.
	GPIO_FALL_IE_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_FALL_IE_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_FALL_IE_PIN5      = 0x20       // Bit PIN5.
	GPIO_FALL_IE_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_FALL_IE_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_FALL_IE_PIN6      = 0x40       // Bit PIN6.
	GPIO_FALL_IE_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_FALL_IE_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_FALL_IE_PIN7      = 0x80       // Bit PIN7.
	GPIO_FALL_IE_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_FALL_IE_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_FALL_IE_PIN8      = 0x100      // Bit PIN8.
	GPIO_FALL_IE_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_FALL_IE_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_FALL_IE_PIN9      = 0x200      // Bit PIN9.
	GPIO_FALL_IE_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_FALL_IE_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_FALL_IE_PIN10     = 0x400      // Bit PIN10.
	GPIO_FALL_IE_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_FALL_IE_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_FALL_IE_PIN11     = 0x800      // Bit PIN11.
	GPIO_FALL_IE_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_FALL_IE_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_FALL_IE_PIN12     = 0x1000     // Bit PIN12.
	GPIO_FALL_IE_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_FALL_IE_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_FALL_IE_PIN13     = 0x2000     // Bit PIN13.
	GPIO_FALL_IE_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_FALL_IE_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_FALL_IE_PIN14     = 0x4000     // Bit PIN14.
	GPIO_FALL_IE_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_FALL_IE_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_FALL_IE_PIN15     = 0x8000     // Bit PIN15.
	GPIO_FALL_IE_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_FALL_IE_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_FALL_IE_PIN16     = 0x10000    // Bit PIN16.
	GPIO_FALL_IE_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_FALL_IE_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_FALL_IE_PIN17     = 0x20000    // Bit PIN17.
	GPIO_FALL_IE_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_FALL_IE_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_FALL_IE_PIN18     = 0x40000    // Bit PIN18.
	GPIO_FALL_IE_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_FALL_IE_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_FALL_IE_PIN19     = 0x80000    // Bit PIN19.
	GPIO_FALL_IE_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_FALL_IE_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_FALL_IE_PIN20     = 0x100000   // Bit PIN20.
	GPIO_FALL_IE_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_FALL_IE_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_FALL_IE_PIN21     = 0x200000   // Bit PIN21.
	GPIO_FALL_IE_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_FALL_IE_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_FALL_IE_PIN22     = 0x400000   // Bit PIN22.
	GPIO_FALL_IE_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_FALL_IE_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_FALL_IE_PIN23     = 0x800000   // Bit PIN23.
	GPIO_FALL_IE_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_FALL_IE_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_FALL_IE_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_FALL_IE_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_FALL_IE_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_FALL_IE_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_FALL_IE_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_FALL_IE_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_FALL_IE_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_FALL_IE_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_FALL_IE_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_FALL_IE_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_FALL_IE_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_FALL_IE_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_FALL_IE_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_FALL_IE_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_FALL_IE_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_FALL_IE_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_FALL_IE_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_FALL_IE_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_FALL_IE_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_FALL_IE_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_FALL_IE_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_FALL_IE_PIN31     = 0x80000000 // Bit PIN31.

	// FALL_IP: Fall Interrupt Pending Register
	GPIO_FALL_IP_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_FALL_IP_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_FALL_IP_PIN0      = 0x1        // Bit PIN0.
	GPIO_FALL_IP_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_FALL_IP_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_FALL_IP_PIN1      = 0x2        // Bit PIN1.
	GPIO_FALL_IP_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_FALL_IP_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_FALL_IP_PIN2      = 0x4        // Bit PIN2.
	GPIO_FALL_IP_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_FALL_IP_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_FALL_IP_PIN3      = 0x8        // Bit PIN3.
	GPIO_FALL_IP_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_FALL_IP_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_FALL_IP_PIN4      = 0x10       // Bit PIN4.
	GPIO_FALL_IP_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_FALL_IP_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_FALL_IP_PIN5      = 0x20       // Bit PIN5.
	GPIO_FALL_IP_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_FALL_IP_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_FALL_IP_PIN6      = 0x40       // Bit PIN6.
	GPIO_FALL_IP_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_FALL_IP_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_FALL_IP_PIN7      = 0x80       // Bit PIN7.
	GPIO_FALL_IP_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_FALL_IP_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_FALL_IP_PIN8      = 0x100      // Bit PIN8.
	GPIO_FALL_IP_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_FALL_IP_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_FALL_IP_PIN9      = 0x200      // Bit PIN9.
	GPIO_FALL_IP_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_FALL_IP_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_FALL_IP_PIN10     = 0x400      // Bit PIN10.
	GPIO_FALL_IP_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_FALL_IP_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_FALL_IP_PIN11     = 0x800      // Bit PIN11.
	GPIO_FALL_IP_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_FALL_IP_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_FALL_IP_PIN12     = 0x1000     // Bit PIN12.
	GPIO_FALL_IP_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_FALL_IP_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_FALL_IP_PIN13     = 0x2000     // Bit PIN13.
	GPIO_FALL_IP_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_FALL_IP_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_FALL_IP_PIN14     = 0x4000     // Bit PIN14.
	GPIO_FALL_IP_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_FALL_IP_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_FALL_IP_PIN15     = 0x8000     // Bit PIN15.
	GPIO_FALL_IP_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_FALL_IP_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_FALL_IP_PIN16     = 0x10000    // Bit PIN16.
	GPIO_FALL_IP_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_FALL_IP_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_FALL_IP_PIN17     = 0x20000    // Bit PIN17.
	GPIO_FALL_IP_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_FALL_IP_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_FALL_IP_PIN18     = 0x40000    // Bit PIN18.
	GPIO_FALL_IP_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_FALL_IP_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_FALL_IP_PIN19     = 0x80000    // Bit PIN19.
	GPIO_FALL_IP_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_FALL_IP_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_FALL_IP_PIN20     = 0x100000   // Bit PIN20.
	GPIO_FALL_IP_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_FALL_IP_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_FALL_IP_PIN21     = 0x200000   // Bit PIN21.
	GPIO_FALL_IP_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_FALL_IP_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_FALL_IP_PIN22     = 0x400000   // Bit PIN22.
	GPIO_FALL_IP_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_FALL_IP_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_FALL_IP_PIN23     = 0x800000   // Bit PIN23.
	GPIO_FALL_IP_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_FALL_IP_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_FALL_IP_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_FALL_IP_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_FALL_IP_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_FALL_IP_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_FALL_IP_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_FALL_IP_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_FALL_IP_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_FALL_IP_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_FALL_IP_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_FALL_IP_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_FALL_IP_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_FALL_IP_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_FALL_IP_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_FALL_IP_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_FALL_IP_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_FALL_IP_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_FALL_IP_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_FALL_IP_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_FALL_IP_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_FALL_IP_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_FALL_IP_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_FALL_IP_PIN31     = 0x80000000 // Bit PIN31.

	// HIGH_IE: High Interrupt Enable Register
	GPIO_HIGH_IE_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_HIGH_IE_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_HIGH_IE_PIN0      = 0x1        // Bit PIN0.
	GPIO_HIGH_IE_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_HIGH_IE_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_HIGH_IE_PIN1      = 0x2        // Bit PIN1.
	GPIO_HIGH_IE_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_HIGH_IE_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_HIGH_IE_PIN2      = 0x4        // Bit PIN2.
	GPIO_HIGH_IE_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_HIGH_IE_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_HIGH_IE_PIN3      = 0x8        // Bit PIN3.
	GPIO_HIGH_IE_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_HIGH_IE_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_HIGH_IE_PIN4      = 0x10       // Bit PIN4.
	GPIO_HIGH_IE_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_HIGH_IE_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_HIGH_IE_PIN5      = 0x20       // Bit PIN5.
	GPIO_HIGH_IE_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_HIGH_IE_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_HIGH_IE_PIN6      = 0x40       // Bit PIN6.
	GPIO_HIGH_IE_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_HIGH_IE_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_HIGH_IE_PIN7      = 0x80       // Bit PIN7.
	GPIO_HIGH_IE_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_HIGH_IE_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_HIGH_IE_PIN8      = 0x100      // Bit PIN8.
	GPIO_HIGH_IE_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_HIGH_IE_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_HIGH_IE_PIN9      = 0x200      // Bit PIN9.
	GPIO_HIGH_IE_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_HIGH_IE_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_HIGH_IE_PIN10     = 0x400      // Bit PIN10.
	GPIO_HIGH_IE_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_HIGH_IE_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_HIGH_IE_PIN11     = 0x800      // Bit PIN11.
	GPIO_HIGH_IE_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_HIGH_IE_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_HIGH_IE_PIN12     = 0x1000     // Bit PIN12.
	GPIO_HIGH_IE_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_HIGH_IE_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_HIGH_IE_PIN13     = 0x2000     // Bit PIN13.
	GPIO_HIGH_IE_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_HIGH_IE_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_HIGH_IE_PIN14     = 0x4000     // Bit PIN14.
	GPIO_HIGH_IE_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_HIGH_IE_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_HIGH_IE_PIN15     = 0x8000     // Bit PIN15.
	GPIO_HIGH_IE_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_HIGH_IE_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_HIGH_IE_PIN16     = 0x10000    // Bit PIN16.
	GPIO_HIGH_IE_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_HIGH_IE_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_HIGH_IE_PIN17     = 0x20000    // Bit PIN17.
	GPIO_HIGH_IE_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_HIGH_IE_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_HIGH_IE_PIN18     = 0x40000    // Bit PIN18.
	GPIO_HIGH_IE_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_HIGH_IE_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_HIGH_IE_PIN19     = 0x80000    // Bit PIN19.
	GPIO_HIGH_IE_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_HIGH_IE_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_HIGH_IE_PIN20     = 0x100000   // Bit PIN20.
	GPIO_HIGH_IE_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_HIGH_IE_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_HIGH_IE_PIN21     = 0x200000   // Bit PIN21.
	GPIO_HIGH_IE_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_HIGH_IE_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_HIGH_IE_PIN22     = 0x400000   // Bit PIN22.
	GPIO_HIGH_IE_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_HIGH_IE_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_HIGH_IE_PIN23     = 0x800000   // Bit PIN23.
	GPIO_HIGH_IE_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_HIGH_IE_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_HIGH_IE_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_HIGH_IE_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_HIGH_IE_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_HIGH_IE_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_HIGH_IE_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_HIGH_IE_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_HIGH_IE_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_HIGH_IE_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_HIGH_IE_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_HIGH_IE_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_HIGH_IE_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_HIGH_IE_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_HIGH_IE_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_HIGH_IE_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_HIGH_IE_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_HIGH_IE_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_HIGH_IE_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_HIGH_IE_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_HIGH_IE_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_HIGH_IE_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_HIGH_IE_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_HIGH_IE_PIN31     = 0x80000000 // Bit PIN31.

	// HIGH_IP: High Interrupt Pending Register
	GPIO_HIGH_IP_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_HIGH_IP_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_HIGH_IP_PIN0      = 0x1        // Bit PIN0.
	GPIO_HIGH_IP_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_HIGH_IP_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_HIGH_IP_PIN1      = 0x2        // Bit PIN1.
	GPIO_HIGH_IP_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_HIGH_IP_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_HIGH_IP_PIN2      = 0x4        // Bit PIN2.
	GPIO_HIGH_IP_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_HIGH_IP_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_HIGH_IP_PIN3      = 0x8        // Bit PIN3.
	GPIO_HIGH_IP_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_HIGH_IP_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_HIGH_IP_PIN4      = 0x10       // Bit PIN4.
	GPIO_HIGH_IP_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_HIGH_IP_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_HIGH_IP_PIN5      = 0x20       // Bit PIN5.
	GPIO_HIGH_IP_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_HIGH_IP_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_HIGH_IP_PIN6      = 0x40       // Bit PIN6.
	GPIO_HIGH_IP_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_HIGH_IP_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_HIGH_IP_PIN7      = 0x80       // Bit PIN7.
	GPIO_HIGH_IP_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_HIGH_IP_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_HIGH_IP_PIN8      = 0x100      // Bit PIN8.
	GPIO_HIGH_IP_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_HIGH_IP_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_HIGH_IP_PIN9      = 0x200      // Bit PIN9.
	GPIO_HIGH_IP_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_HIGH_IP_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_HIGH_IP_PIN10     = 0x400      // Bit PIN10.
	GPIO_HIGH_IP_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_HIGH_IP_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_HIGH_IP_PIN11     = 0x800      // Bit PIN11.
	GPIO_HIGH_IP_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_HIGH_IP_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_HIGH_IP_PIN12     = 0x1000     // Bit PIN12.
	GPIO_HIGH_IP_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_HIGH_IP_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_HIGH_IP_PIN13     = 0x2000     // Bit PIN13.
	GPIO_HIGH_IP_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_HIGH_IP_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_HIGH_IP_PIN14     = 0x4000     // Bit PIN14.
	GPIO_HIGH_IP_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_HIGH_IP_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_HIGH_IP_PIN15     = 0x8000     // Bit PIN15.
	GPIO_HIGH_IP_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_HIGH_IP_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_HIGH_IP_PIN16     = 0x10000    // Bit PIN16.
	GPIO_HIGH_IP_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_HIGH_IP_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_HIGH_IP_PIN17     = 0x20000    // Bit PIN17.
	GPIO_HIGH_IP_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_HIGH_IP_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_HIGH_IP_PIN18     = 0x40000    // Bit PIN18.
	GPIO_HIGH_IP_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_HIGH_IP_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_HIGH_IP_PIN19     = 0x80000    // Bit PIN19.
	GPIO_HIGH_IP_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_HIGH_IP_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_HIGH_IP_PIN20     = 0x100000   // Bit PIN20.
	GPIO_HIGH_IP_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_HIGH_IP_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_HIGH_IP_PIN21     = 0x200000   // Bit PIN21.
	GPIO_HIGH_IP_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_HIGH_IP_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_HIGH_IP_PIN22     = 0x400000   // Bit PIN22.
	GPIO_HIGH_IP_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_HIGH_IP_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_HIGH_IP_PIN23     = 0x800000   // Bit PIN23.
	GPIO_HIGH_IP_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_HIGH_IP_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_HIGH_IP_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_HIGH_IP_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_HIGH_IP_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_HIGH_IP_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_HIGH_IP_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_HIGH_IP_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_HIGH_IP_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_HIGH_IP_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_HIGH_IP_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_HIGH_IP_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_HIGH_IP_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_HIGH_IP_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_HIGH_IP_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_HIGH_IP_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_HIGH_IP_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_HIGH_IP_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_HIGH_IP_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_HIGH_IP_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_HIGH_IP_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_HIGH_IP_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_HIGH_IP_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_HIGH_IP_PIN31     = 0x80000000 // Bit PIN31.

	// LOW_IE: Low Interrupt Enable Register
	GPIO_LOW_IE_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_LOW_IE_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_LOW_IE_PIN0      = 0x1        // Bit PIN0.
	GPIO_LOW_IE_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_LOW_IE_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_LOW_IE_PIN1      = 0x2        // Bit PIN1.
	GPIO_LOW_IE_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_LOW_IE_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_LOW_IE_PIN2      = 0x4        // Bit PIN2.
	GPIO_LOW_IE_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_LOW_IE_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_LOW_IE_PIN3      = 0x8        // Bit PIN3.
	GPIO_LOW_IE_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_LOW_IE_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_LOW_IE_PIN4      = 0x10       // Bit PIN4.
	GPIO_LOW_IE_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_LOW_IE_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_LOW_IE_PIN5      = 0x20       // Bit PIN5.
	GPIO_LOW_IE_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_LOW_IE_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_LOW_IE_PIN6      = 0x40       // Bit PIN6.
	GPIO_LOW_IE_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_LOW_IE_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_LOW_IE_PIN7      = 0x80       // Bit PIN7.
	GPIO_LOW_IE_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_LOW_IE_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_LOW_IE_PIN8      = 0x100      // Bit PIN8.
	GPIO_LOW_IE_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_LOW_IE_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_LOW_IE_PIN9      = 0x200      // Bit PIN9.
	GPIO_LOW_IE_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_LOW_IE_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_LOW_IE_PIN10     = 0x400      // Bit PIN10.
	GPIO_LOW_IE_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_LOW_IE_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_LOW_IE_PIN11     = 0x800      // Bit PIN11.
	GPIO_LOW_IE_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_LOW_IE_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_LOW_IE_PIN12     = 0x1000     // Bit PIN12.
	GPIO_LOW_IE_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_LOW_IE_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_LOW_IE_PIN13     = 0x2000     // Bit PIN13.
	GPIO_LOW_IE_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_LOW_IE_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_LOW_IE_PIN14     = 0x4000     // Bit PIN14.
	GPIO_LOW_IE_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_LOW_IE_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_LOW_IE_PIN15     = 0x8000     // Bit PIN15.
	GPIO_LOW_IE_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_LOW_IE_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_LOW_IE_PIN16     = 0x10000    // Bit PIN16.
	GPIO_LOW_IE_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_LOW_IE_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_LOW_IE_PIN17     = 0x20000    // Bit PIN17.
	GPIO_LOW_IE_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_LOW_IE_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_LOW_IE_PIN18     = 0x40000    // Bit PIN18.
	GPIO_LOW_IE_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_LOW_IE_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_LOW_IE_PIN19     = 0x80000    // Bit PIN19.
	GPIO_LOW_IE_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_LOW_IE_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_LOW_IE_PIN20     = 0x100000   // Bit PIN20.
	GPIO_LOW_IE_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_LOW_IE_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_LOW_IE_PIN21     = 0x200000   // Bit PIN21.
	GPIO_LOW_IE_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_LOW_IE_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_LOW_IE_PIN22     = 0x400000   // Bit PIN22.
	GPIO_LOW_IE_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_LOW_IE_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_LOW_IE_PIN23     = 0x800000   // Bit PIN23.
	GPIO_LOW_IE_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_LOW_IE_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_LOW_IE_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_LOW_IE_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_LOW_IE_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_LOW_IE_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_LOW_IE_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_LOW_IE_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_LOW_IE_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_LOW_IE_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_LOW_IE_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_LOW_IE_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_LOW_IE_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_LOW_IE_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_LOW_IE_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_LOW_IE_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_LOW_IE_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_LOW_IE_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_LOW_IE_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_LOW_IE_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_LOW_IE_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_LOW_IE_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_LOW_IE_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_LOW_IE_PIN31     = 0x80000000 // Bit PIN31.

	// LOW_IP: Low Interrupt Pending Register
	GPIO_LOW_IP_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_LOW_IP_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_LOW_IP_PIN0      = 0x1        // Bit PIN0.
	GPIO_LOW_IP_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_LOW_IP_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_LOW_IP_PIN1      = 0x2        // Bit PIN1.
	GPIO_LOW_IP_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_LOW_IP_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_LOW_IP_PIN2      = 0x4        // Bit PIN2.
	GPIO_LOW_IP_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_LOW_IP_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_LOW_IP_PIN3      = 0x8        // Bit PIN3.
	GPIO_LOW_IP_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_LOW_IP_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_LOW_IP_PIN4      = 0x10       // Bit PIN4.
	GPIO_LOW_IP_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_LOW_IP_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_LOW_IP_PIN5      = 0x20       // Bit PIN5.
	GPIO_LOW_IP_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_LOW_IP_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_LOW_IP_PIN6      = 0x40       // Bit PIN6.
	GPIO_LOW_IP_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_LOW_IP_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_LOW_IP_PIN7      = 0x80       // Bit PIN7.
	GPIO_LOW_IP_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_LOW_IP_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_LOW_IP_PIN8      = 0x100      // Bit PIN8.
	GPIO_LOW_IP_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_LOW_IP_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_LOW_IP_PIN9      = 0x200      // Bit PIN9.
	GPIO_LOW_IP_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_LOW_IP_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_LOW_IP_PIN10     = 0x400      // Bit PIN10.
	GPIO_LOW_IP_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_LOW_IP_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_LOW_IP_PIN11     = 0x800      // Bit PIN11.
	GPIO_LOW_IP_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_LOW_IP_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_LOW_IP_PIN12     = 0x1000     // Bit PIN12.
	GPIO_LOW_IP_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_LOW_IP_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_LOW_IP_PIN13     = 0x2000     // Bit PIN13.
	GPIO_LOW_IP_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_LOW_IP_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_LOW_IP_PIN14     = 0x4000     // Bit PIN14.
	GPIO_LOW_IP_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_LOW_IP_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_LOW_IP_PIN15     = 0x8000     // Bit PIN15.
	GPIO_LOW_IP_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_LOW_IP_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_LOW_IP_PIN16     = 0x10000    // Bit PIN16.
	GPIO_LOW_IP_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_LOW_IP_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_LOW_IP_PIN17     = 0x20000    // Bit PIN17.
	GPIO_LOW_IP_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_LOW_IP_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_LOW_IP_PIN18     = 0x40000    // Bit PIN18.
	GPIO_LOW_IP_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_LOW_IP_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_LOW_IP_PIN19     = 0x80000    // Bit PIN19.
	GPIO_LOW_IP_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_LOW_IP_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_LOW_IP_PIN20     = 0x100000   // Bit PIN20.
	GPIO_LOW_IP_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_LOW_IP_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_LOW_IP_PIN21     = 0x200000   // Bit PIN21.
	GPIO_LOW_IP_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_LOW_IP_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_LOW_IP_PIN22     = 0x400000   // Bit PIN22.
	GPIO_LOW_IP_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_LOW_IP_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_LOW_IP_PIN23     = 0x800000   // Bit PIN23.
	GPIO_LOW_IP_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_LOW_IP_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_LOW_IP_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_LOW_IP_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_LOW_IP_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_LOW_IP_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_LOW_IP_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_LOW_IP_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_LOW_IP_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_LOW_IP_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_LOW_IP_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_LOW_IP_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_LOW_IP_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_LOW_IP_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_LOW_IP_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_LOW_IP_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_LOW_IP_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_LOW_IP_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_LOW_IP_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_LOW_IP_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_LOW_IP_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_LOW_IP_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_LOW_IP_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_LOW_IP_PIN31     = 0x80000000 // Bit PIN31.

	// IOF_EN: HW I/O Function Enable Register
	GPIO_IOF_EN_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_IOF_EN_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_IOF_EN_PIN0      = 0x1        // Bit PIN0.
	GPIO_IOF_EN_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_IOF_EN_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_IOF_EN_PIN1      = 0x2        // Bit PIN1.
	GPIO_IOF_EN_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_IOF_EN_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_IOF_EN_PIN2      = 0x4        // Bit PIN2.
	GPIO_IOF_EN_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_IOF_EN_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_IOF_EN_PIN3      = 0x8        // Bit PIN3.
	GPIO_IOF_EN_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_IOF_EN_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_IOF_EN_PIN4      = 0x10       // Bit PIN4.
	GPIO_IOF_EN_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_IOF_EN_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_IOF_EN_PIN5      = 0x20       // Bit PIN5.
	GPIO_IOF_EN_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_IOF_EN_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_IOF_EN_PIN6      = 0x40       // Bit PIN6.
	GPIO_IOF_EN_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_IOF_EN_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_IOF_EN_PIN7      = 0x80       // Bit PIN7.
	GPIO_IOF_EN_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_IOF_EN_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_IOF_EN_PIN8      = 0x100      // Bit PIN8.
	GPIO_IOF_EN_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_IOF_EN_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_IOF_EN_PIN9      = 0x200      // Bit PIN9.
	GPIO_IOF_EN_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_IOF_EN_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_IOF_EN_PIN10     = 0x400      // Bit PIN10.
	GPIO_IOF_EN_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_IOF_EN_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_IOF_EN_PIN11     = 0x800      // Bit PIN11.
	GPIO_IOF_EN_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_IOF_EN_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_IOF_EN_PIN12     = 0x1000     // Bit PIN12.
	GPIO_IOF_EN_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_IOF_EN_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_IOF_EN_PIN13     = 0x2000     // Bit PIN13.
	GPIO_IOF_EN_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_IOF_EN_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_IOF_EN_PIN14     = 0x4000     // Bit PIN14.
	GPIO_IOF_EN_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_IOF_EN_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_IOF_EN_PIN15     = 0x8000     // Bit PIN15.
	GPIO_IOF_EN_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_IOF_EN_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_IOF_EN_PIN16     = 0x10000    // Bit PIN16.
	GPIO_IOF_EN_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_IOF_EN_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_IOF_EN_PIN17     = 0x20000    // Bit PIN17.
	GPIO_IOF_EN_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_IOF_EN_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_IOF_EN_PIN18     = 0x40000    // Bit PIN18.
	GPIO_IOF_EN_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_IOF_EN_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_IOF_EN_PIN19     = 0x80000    // Bit PIN19.
	GPIO_IOF_EN_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_IOF_EN_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_IOF_EN_PIN20     = 0x100000   // Bit PIN20.
	GPIO_IOF_EN_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_IOF_EN_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_IOF_EN_PIN21     = 0x200000   // Bit PIN21.
	GPIO_IOF_EN_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_IOF_EN_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_IOF_EN_PIN22     = 0x400000   // Bit PIN22.
	GPIO_IOF_EN_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_IOF_EN_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_IOF_EN_PIN23     = 0x800000   // Bit PIN23.
	GPIO_IOF_EN_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_IOF_EN_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_IOF_EN_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_IOF_EN_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_IOF_EN_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_IOF_EN_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_IOF_EN_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_IOF_EN_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_IOF_EN_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_IOF_EN_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_IOF_EN_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_IOF_EN_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_IOF_EN_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_IOF_EN_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_IOF_EN_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_IOF_EN_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_IOF_EN_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_IOF_EN_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_IOF_EN_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_IOF_EN_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_IOF_EN_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_IOF_EN_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_IOF_EN_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_IOF_EN_PIN31     = 0x80000000 // Bit PIN31.

	// IOF_SEL: HW I/O Function Select Register
	GPIO_IOF_SEL_PIN0_Pos        = 0x0 // Position of PIN0 field.
	GPIO_IOF_SEL_PIN0_Msk        = 0x1 // Bit mask of PIN0 field.
	GPIO_IOF_SEL_PIN0            = 0x1 // Bit PIN0.
	GPIO_IOF_SEL_PIN0_IOF0       = 0x0
	GPIO_IOF_SEL_PIN0_PWM0_0     = 0x1
	GPIO_IOF_SEL_PIN1_Pos        = 0x1 // Position of PIN1 field.
	GPIO_IOF_SEL_PIN1_Msk        = 0x2 // Bit mask of PIN1 field.
	GPIO_IOF_SEL_PIN1            = 0x2 // Bit PIN1.
	GPIO_IOF_SEL_PIN1_IOF0       = 0x0
	GPIO_IOF_SEL_PIN1_PWM0_1     = 0x1
	GPIO_IOF_SEL_PIN2_Pos        = 0x2 // Position of PIN2 field.
	GPIO_IOF_SEL_PIN2_Msk        = 0x4 // Bit mask of PIN2 field.
	GPIO_IOF_SEL_PIN2            = 0x4 // Bit PIN2.
	GPIO_IOF_SEL_PIN2_QSPI1_SS0  = 0x0
	GPIO_IOF_SEL_PIN2_PWM0_2     = 0x1
	GPIO_IOF_SEL_PIN3_Pos        = 0x3 // Position of PIN3 field.
	GPIO_IOF_SEL_PIN3_Msk        = 0x8 // Bit mask of PIN3 field.
	GPIO_IOF_SEL_PIN3            = 0x8 // Bit PIN3.
	GPIO_IOF_SEL_PIN3_QSPI1_SD0  = 0x0
	GPIO_IOF_SEL_PIN3_PWM0_3     = 0x1
	GPIO_IOF_SEL_PIN4_Pos        = 0x4  // Position of PIN4 field.
	GPIO_IOF_SEL_PIN4_Msk        = 0x10 // Bit mask of PIN4 field.
	GPIO_IOF_SEL_PIN4            = 0x10 // Bit PIN4.
	GPIO_IOF_SEL_PIN4_QSPI1_SD1  = 0x0
	GPIO_IOF_SEL_PIN4_IOF1       = 0x1
	GPIO_IOF_SEL_PIN5_Pos        = 0x5  // Position of PIN5 field.
	GPIO_IOF_SEL_PIN5_Msk        = 0x20 // Bit mask of PIN5 field.
	GPIO_IOF_SEL_PIN5            = 0x20 // Bit PIN5.
	GPIO_IOF_SEL_PIN5_QSPI1_SCK  = 0x0
	GPIO_IOF_SEL_PIN5_IOF1       = 0x1
	GPIO_IOF_SEL_PIN6_Pos        = 0x6  // Position of PIN6 field.
	GPIO_IOF_SEL_PIN6_Msk        = 0x40 // Bit mask of PIN6 field.
	GPIO_IOF_SEL_PIN6            = 0x40 // Bit PIN6.
	GPIO_IOF_SEL_PIN6_QSPI1_SD2  = 0x0
	GPIO_IOF_SEL_PIN6_IOF1       = 0x1
	GPIO_IOF_SEL_PIN7_Pos        = 0x7  // Position of PIN7 field.
	GPIO_IOF_SEL_PIN7_Msk        = 0x80 // Bit mask of PIN7 field.
	GPIO_IOF_SEL_PIN7            = 0x80 // Bit PIN7.
	GPIO_IOF_SEL_PIN7_QSPI1_SD3  = 0x0
	GPIO_IOF_SEL_PIN7_IOF1       = 0x1
	GPIO_IOF_SEL_PIN8_Pos        = 0x8   // Position of PIN8 field.
	GPIO_IOF_SEL_PIN8_Msk        = 0x100 // Bit mask of PIN8 field.
	GPIO_IOF_SEL_PIN8            = 0x100 // Bit PIN8.
	GPIO_IOF_SEL_PIN8_QSPI1_SS1  = 0x0
	GPIO_IOF_SEL_PIN8_IOF1       = 0x1
	GPIO_IOF_SEL_PIN9_Pos        = 0x9   // Position of PIN9 field.
	GPIO_IOF_SEL_PIN9_Msk        = 0x200 // Bit mask of PIN9 field.
	GPIO_IOF_SEL_PIN9            = 0x200 // Bit PIN9.
	GPIO_IOF_SEL_PIN9_QSPI1_SS2  = 0x0
	GPIO_IOF_SEL_PIN9_IOF1       = 0x1
	GPIO_IOF_SEL_PIN10_Pos       = 0xa   // Position of PIN10 field.
	GPIO_IOF_SEL_PIN10_Msk       = 0x400 // Bit mask of PIN10 field.
	GPIO_IOF_SEL_PIN10           = 0x400 // Bit PIN10.
	GPIO_IOF_SEL_PIN10_QSPI1_SS3 = 0x0
	GPIO_IOF_SEL_PIN10_PWM2_0    = 0x1
	GPIO_IOF_SEL_PIN11_Pos       = 0xb   // Position of PIN11 field.
	GPIO_IOF_SEL_PIN11_Msk       = 0x800 // Bit mask of PIN11 field.
	GPIO_IOF_SEL_PIN11           = 0x800 // Bit PIN11.
	GPIO_IOF_SEL_PIN11_IOF0      = 0x0
	GPIO_IOF_SEL_PIN11_PWM2_1    = 0x1
	GPIO_IOF_SEL_PIN12_Pos       = 0xc    // Position of PIN12 field.
	GPIO_IOF_SEL_PIN12_Msk       = 0x1000 // Bit mask of PIN12 field.
	GPIO_IOF_SEL_PIN12           = 0x1000 // Bit PIN12.
	GPIO_IOF_SEL_PIN12_IOF0      = 0x0
	GPIO_IOF_SEL_PIN12_PWM2_2    = 0x1
	GPIO_IOF_SEL_PIN13_Pos       = 0xd    // Position of PIN13 field.
	GPIO_IOF_SEL_PIN13_Msk       = 0x2000 // Bit mask of PIN13 field.
	GPIO_IOF_SEL_PIN13           = 0x2000 // Bit PIN13.
	GPIO_IOF_SEL_PIN13_IOF0      = 0x0
	GPIO_IOF_SEL_PIN13_PWM2_3    = 0x1
	GPIO_IOF_SEL_PIN14_Pos       = 0xe    // Position of PIN14 field.
	GPIO_IOF_SEL_PIN14_Msk       = 0x4000 // Bit mask of PIN14 field.
	GPIO_IOF_SEL_PIN14           = 0x4000 // Bit PIN14.
	GPIO_IOF_SEL_PIN14_IOF0      = 0x0
	GPIO_IOF_SEL_PIN14_IOF1      = 0x1
	GPIO_IOF_SEL_PIN15_Pos       = 0xf    // Position of PIN15 field.
	GPIO_IOF_SEL_PIN15_Msk       = 0x8000 // Bit mask of PIN15 field.
	GPIO_IOF_SEL_PIN15           = 0x8000 // Bit PIN15.
	GPIO_IOF_SEL_PIN15_IOF0      = 0x0
	GPIO_IOF_SEL_PIN15_IOF1      = 0x1
	GPIO_IOF_SEL_PIN16_Pos       = 0x10    // Position of PIN16 field.
	GPIO_IOF_SEL_PIN16_Msk       = 0x10000 // Bit mask of PIN16 field.
	GPIO_IOF_SEL_PIN16           = 0x10000 // Bit PIN16.
	GPIO_IOF_SEL_PIN16_UART0_RX  = 0x0
	GPIO_IOF_SEL_PIN16_IOF1      = 0x1
	GPIO_IOF_SEL_PIN17_Pos       = 0x11    // Position of PIN17 field.
	GPIO_IOF_SEL_PIN17_Msk       = 0x20000 // Bit mask of PIN17 field.
	GPIO_IOF_SEL_PIN17           = 0x20000 // Bit PIN17.
	GPIO_IOF_SEL_PIN17_UART0_TX  = 0x0
	GPIO_IOF_SEL_PIN17_IOF1      = 0x1
	GPIO_IOF_SEL_PIN18_Pos       = 0x12    // Position of PIN18 field.
	GPIO_IOF_SEL_PIN18_Msk       = 0x40000 // Bit mask of PIN18 field.
	GPIO_IOF_SEL_PIN18           = 0x40000 // Bit PIN18.
	GPIO_IOF_SEL_PIN18_IOF0      = 0x0
	GPIO_IOF_SEL_PIN18_IOF1      = 0x1
	GPIO_IOF_SEL_PIN19_Pos       = 0x13    // Position of PIN19 field.
	GPIO_IOF_SEL_PIN19_Msk       = 0x80000 // Bit mask of PIN19 field.
	GPIO_IOF_SEL_PIN19           = 0x80000 // Bit PIN19.
	GPIO_IOF_SEL_PIN19_IOF0      = 0x0
	GPIO_IOF_SEL_PIN19_PWM1_1    = 0x1
	GPIO_IOF_SEL_PIN20_Pos       = 0x14     // Position of PIN20 field.
	GPIO_IOF_SEL_PIN20_Msk       = 0x100000 // Bit mask of PIN20 field.
	GPIO_IOF_SEL_PIN20           = 0x100000 // Bit PIN20.
	GPIO_IOF_SEL_PIN20_IOF0      = 0x0
	GPIO_IOF_SEL_PIN20_PWM1_0    = 0x1
	GPIO_IOF_SEL_PIN21_Pos       = 0x15     // Position of PIN21 field.
	GPIO_IOF_SEL_PIN21_Msk       = 0x200000 // Bit mask of PIN21 field.
	GPIO_IOF_SEL_PIN21           = 0x200000 // Bit PIN21.
	GPIO_IOF_SEL_PIN21_IOF0      = 0x0
	GPIO_IOF_SEL_PIN21_PWM1_2    = 0x1
	GPIO_IOF_SEL_PIN22_Pos       = 0x16     // Position of PIN22 field.
	GPIO_IOF_SEL_PIN22_Msk       = 0x400000 // Bit mask of PIN22 field.
	GPIO_IOF_SEL_PIN22           = 0x400000 // Bit PIN22.
	GPIO_IOF_SEL_PIN22_IOF0      = 0x0
	GPIO_IOF_SEL_PIN22_PWM1_3    = 0x1
	GPIO_IOF_SEL_PIN23_Pos       = 0x17     // Position of PIN23 field.
	GPIO_IOF_SEL_PIN23_Msk       = 0x800000 // Bit mask of PIN23 field.
	GPIO_IOF_SEL_PIN23           = 0x800000 // Bit PIN23.
	GPIO_IOF_SEL_PIN23_IOF0      = 0x0
	GPIO_IOF_SEL_PIN23_IOF1      = 0x1
	GPIO_IOF_SEL_PIN24_Pos       = 0x18      // Position of PIN24 field.
	GPIO_IOF_SEL_PIN24_Msk       = 0x1000000 // Bit mask of PIN24 field.
	GPIO_IOF_SEL_PIN24           = 0x1000000 // Bit PIN24.
	GPIO_IOF_SEL_PIN24_UART1_RX  = 0x0
	GPIO_IOF_SEL_PIN24_IOF1      = 0x1
	GPIO_IOF_SEL_PIN25_Pos       = 0x19      // Position of PIN25 field.
	GPIO_IOF_SEL_PIN25_Msk       = 0x2000000 // Bit mask of PIN25 field.
	GPIO_IOF_SEL_PIN25           = 0x2000000 // Bit PIN25.
	GPIO_IOF_SEL_PIN25_UART1_TX  = 0x0
	GPIO_IOF_SEL_PIN25_IOF1      = 0x1
	GPIO_IOF_SEL_PIN26_Pos       = 0x1a      // Position of PIN26 field.
	GPIO_IOF_SEL_PIN26_Msk       = 0x4000000 // Bit mask of PIN26 field.
	GPIO_IOF_SEL_PIN26           = 0x4000000 // Bit PIN26.
	GPIO_IOF_SEL_PIN26_QSPI2_SS  = 0x0
	GPIO_IOF_SEL_PIN26_IOF1      = 0x1
	GPIO_IOF_SEL_PIN27_Pos       = 0x1b      // Position of PIN27 field.
	GPIO_IOF_SEL_PIN27_Msk       = 0x8000000 // Bit mask of PIN27 field.
	GPIO_IOF_SEL_PIN27           = 0x8000000 // Bit PIN27.
	GPIO_IOF_SEL_PIN27_QSPI2_SD0 = 0x0
	GPIO_IOF_SEL_PIN27_IOF1      = 0x1
	GPIO_IOF_SEL_PIN28_Pos       = 0x1c       // Position of PIN28 field.
	GPIO_IOF_SEL_PIN28_Msk       = 0x10000000 // Bit mask of PIN28 field.
	GPIO_IOF_SEL_PIN28           = 0x10000000 // Bit PIN28.
	GPIO_IOF_SEL_PIN28_QSPI2_SD1 = 0x0
	GPIO_IOF_SEL_PIN28_IOF1      = 0x1
	GPIO_IOF_SEL_PIN29_Pos       = 0x1d       // Position of PIN29 field.
	GPIO_IOF_SEL_PIN29_Msk       = 0x20000000 // Bit mask of PIN29 field.
	GPIO_IOF_SEL_PIN29           = 0x20000000 // Bit PIN29.
	GPIO_IOF_SEL_PIN29_QSPI2_SCK = 0x0
	GPIO_IOF_SEL_PIN29_IOF1      = 0x1
	GPIO_IOF_SEL_PIN30_Pos       = 0x1e       // Position of PIN30 field.
	GPIO_IOF_SEL_PIN30_Msk       = 0x40000000 // Bit mask of PIN30 field.
	GPIO_IOF_SEL_PIN30           = 0x40000000 // Bit PIN30.
	GPIO_IOF_SEL_PIN30_QSPI2_SD2 = 0x0
	GPIO_IOF_SEL_PIN30_IOF1      = 0x1
	GPIO_IOF_SEL_PIN31_Pos       = 0x1f       // Position of PIN31 field.
	GPIO_IOF_SEL_PIN31_Msk       = 0x80000000 // Bit mask of PIN31 field.
	GPIO_IOF_SEL_PIN31           = 0x80000000 // Bit PIN31.
	GPIO_IOF_SEL_PIN31_QSPI2_SD3 = 0x0
	GPIO_IOF_SEL_PIN31_IOF1      = 0x1

	// OUT_XOR: Output XOR (invert) Register
	GPIO_OUT_XOR_PIN0_Pos  = 0x0        // Position of PIN0 field.
	GPIO_OUT_XOR_PIN0_Msk  = 0x1        // Bit mask of PIN0 field.
	GPIO_OUT_XOR_PIN0      = 0x1        // Bit PIN0.
	GPIO_OUT_XOR_PIN1_Pos  = 0x1        // Position of PIN1 field.
	GPIO_OUT_XOR_PIN1_Msk  = 0x2        // Bit mask of PIN1 field.
	GPIO_OUT_XOR_PIN1      = 0x2        // Bit PIN1.
	GPIO_OUT_XOR_PIN2_Pos  = 0x2        // Position of PIN2 field.
	GPIO_OUT_XOR_PIN2_Msk  = 0x4        // Bit mask of PIN2 field.
	GPIO_OUT_XOR_PIN2      = 0x4        // Bit PIN2.
	GPIO_OUT_XOR_PIN3_Pos  = 0x3        // Position of PIN3 field.
	GPIO_OUT_XOR_PIN3_Msk  = 0x8        // Bit mask of PIN3 field.
	GPIO_OUT_XOR_PIN3      = 0x8        // Bit PIN3.
	GPIO_OUT_XOR_PIN4_Pos  = 0x4        // Position of PIN4 field.
	GPIO_OUT_XOR_PIN4_Msk  = 0x10       // Bit mask of PIN4 field.
	GPIO_OUT_XOR_PIN4      = 0x10       // Bit PIN4.
	GPIO_OUT_XOR_PIN5_Pos  = 0x5        // Position of PIN5 field.
	GPIO_OUT_XOR_PIN5_Msk  = 0x20       // Bit mask of PIN5 field.
	GPIO_OUT_XOR_PIN5      = 0x20       // Bit PIN5.
	GPIO_OUT_XOR_PIN6_Pos  = 0x6        // Position of PIN6 field.
	GPIO_OUT_XOR_PIN6_Msk  = 0x40       // Bit mask of PIN6 field.
	GPIO_OUT_XOR_PIN6      = 0x40       // Bit PIN6.
	GPIO_OUT_XOR_PIN7_Pos  = 0x7        // Position of PIN7 field.
	GPIO_OUT_XOR_PIN7_Msk  = 0x80       // Bit mask of PIN7 field.
	GPIO_OUT_XOR_PIN7      = 0x80       // Bit PIN7.
	GPIO_OUT_XOR_PIN8_Pos  = 0x8        // Position of PIN8 field.
	GPIO_OUT_XOR_PIN8_Msk  = 0x100      // Bit mask of PIN8 field.
	GPIO_OUT_XOR_PIN8      = 0x100      // Bit PIN8.
	GPIO_OUT_XOR_PIN9_Pos  = 0x9        // Position of PIN9 field.
	GPIO_OUT_XOR_PIN9_Msk  = 0x200      // Bit mask of PIN9 field.
	GPIO_OUT_XOR_PIN9      = 0x200      // Bit PIN9.
	GPIO_OUT_XOR_PIN10_Pos = 0xa        // Position of PIN10 field.
	GPIO_OUT_XOR_PIN10_Msk = 0x400      // Bit mask of PIN10 field.
	GPIO_OUT_XOR_PIN10     = 0x400      // Bit PIN10.
	GPIO_OUT_XOR_PIN11_Pos = 0xb        // Position of PIN11 field.
	GPIO_OUT_XOR_PIN11_Msk = 0x800      // Bit mask of PIN11 field.
	GPIO_OUT_XOR_PIN11     = 0x800      // Bit PIN11.
	GPIO_OUT_XOR_PIN12_Pos = 0xc        // Position of PIN12 field.
	GPIO_OUT_XOR_PIN12_Msk = 0x1000     // Bit mask of PIN12 field.
	GPIO_OUT_XOR_PIN12     = 0x1000     // Bit PIN12.
	GPIO_OUT_XOR_PIN13_Pos = 0xd        // Position of PIN13 field.
	GPIO_OUT_XOR_PIN13_Msk = 0x2000     // Bit mask of PIN13 field.
	GPIO_OUT_XOR_PIN13     = 0x2000     // Bit PIN13.
	GPIO_OUT_XOR_PIN14_Pos = 0xe        // Position of PIN14 field.
	GPIO_OUT_XOR_PIN14_Msk = 0x4000     // Bit mask of PIN14 field.
	GPIO_OUT_XOR_PIN14     = 0x4000     // Bit PIN14.
	GPIO_OUT_XOR_PIN15_Pos = 0xf        // Position of PIN15 field.
	GPIO_OUT_XOR_PIN15_Msk = 0x8000     // Bit mask of PIN15 field.
	GPIO_OUT_XOR_PIN15     = 0x8000     // Bit PIN15.
	GPIO_OUT_XOR_PIN16_Pos = 0x10       // Position of PIN16 field.
	GPIO_OUT_XOR_PIN16_Msk = 0x10000    // Bit mask of PIN16 field.
	GPIO_OUT_XOR_PIN16     = 0x10000    // Bit PIN16.
	GPIO_OUT_XOR_PIN17_Pos = 0x11       // Position of PIN17 field.
	GPIO_OUT_XOR_PIN17_Msk = 0x20000    // Bit mask of PIN17 field.
	GPIO_OUT_XOR_PIN17     = 0x20000    // Bit PIN17.
	GPIO_OUT_XOR_PIN18_Pos = 0x12       // Position of PIN18 field.
	GPIO_OUT_XOR_PIN18_Msk = 0x40000    // Bit mask of PIN18 field.
	GPIO_OUT_XOR_PIN18     = 0x40000    // Bit PIN18.
	GPIO_OUT_XOR_PIN19_Pos = 0x13       // Position of PIN19 field.
	GPIO_OUT_XOR_PIN19_Msk = 0x80000    // Bit mask of PIN19 field.
	GPIO_OUT_XOR_PIN19     = 0x80000    // Bit PIN19.
	GPIO_OUT_XOR_PIN20_Pos = 0x14       // Position of PIN20 field.
	GPIO_OUT_XOR_PIN20_Msk = 0x100000   // Bit mask of PIN20 field.
	GPIO_OUT_XOR_PIN20     = 0x100000   // Bit PIN20.
	GPIO_OUT_XOR_PIN21_Pos = 0x15       // Position of PIN21 field.
	GPIO_OUT_XOR_PIN21_Msk = 0x200000   // Bit mask of PIN21 field.
	GPIO_OUT_XOR_PIN21     = 0x200000   // Bit PIN21.
	GPIO_OUT_XOR_PIN22_Pos = 0x16       // Position of PIN22 field.
	GPIO_OUT_XOR_PIN22_Msk = 0x400000   // Bit mask of PIN22 field.
	GPIO_OUT_XOR_PIN22     = 0x400000   // Bit PIN22.
	GPIO_OUT_XOR_PIN23_Pos = 0x17       // Position of PIN23 field.
	GPIO_OUT_XOR_PIN23_Msk = 0x800000   // Bit mask of PIN23 field.
	GPIO_OUT_XOR_PIN23     = 0x800000   // Bit PIN23.
	GPIO_OUT_XOR_PIN24_Pos = 0x18       // Position of PIN24 field.
	GPIO_OUT_XOR_PIN24_Msk = 0x1000000  // Bit mask of PIN24 field.
	GPIO_OUT_XOR_PIN24     = 0x1000000  // Bit PIN24.
	GPIO_OUT_XOR_PIN25_Pos = 0x19       // Position of PIN25 field.
	GPIO_OUT_XOR_PIN25_Msk = 0x2000000  // Bit mask of PIN25 field.
	GPIO_OUT_XOR_PIN25     = 0x2000000  // Bit PIN25.
	GPIO_OUT_XOR_PIN26_Pos = 0x1a       // Position of PIN26 field.
	GPIO_OUT_XOR_PIN26_Msk = 0x4000000  // Bit mask of PIN26 field.
	GPIO_OUT_XOR_PIN26     = 0x4000000  // Bit PIN26.
	GPIO_OUT_XOR_PIN27_Pos = 0x1b       // Position of PIN27 field.
	GPIO_OUT_XOR_PIN27_Msk = 0x8000000  // Bit mask of PIN27 field.
	GPIO_OUT_XOR_PIN27     = 0x8000000  // Bit PIN27.
	GPIO_OUT_XOR_PIN28_Pos = 0x1c       // Position of PIN28 field.
	GPIO_OUT_XOR_PIN28_Msk = 0x10000000 // Bit mask of PIN28 field.
	GPIO_OUT_XOR_PIN28     = 0x10000000 // Bit PIN28.
	GPIO_OUT_XOR_PIN29_Pos = 0x1d       // Position of PIN29 field.
	GPIO_OUT_XOR_PIN29_Msk = 0x20000000 // Bit mask of PIN29 field.
	GPIO_OUT_XOR_PIN29     = 0x20000000 // Bit PIN29.
	GPIO_OUT_XOR_PIN30_Pos = 0x1e       // Position of PIN30 field.
	GPIO_OUT_XOR_PIN30_Msk = 0x40000000 // Bit mask of PIN30 field.
	GPIO_OUT_XOR_PIN30     = 0x40000000 // Bit PIN30.
	GPIO_OUT_XOR_PIN31_Pos = 0x1f       // Position of PIN31 field.
	GPIO_OUT_XOR_PIN31_Msk = 0x80000000 // Bit mask of PIN31 field.
	GPIO_OUT_XOR_PIN31     = 0x80000000 // Bit PIN31.
)

// Bitfields for UART0: Universal Asynchronous Receiver Transmitter
const (
	// TXDATA: Transmit Data Register
	UART_TXDATA_FULL_Pos = 0x1f       // Position of FULL field.
	UART_TXDATA_FULL_Msk = 0x80000000 // Bit mask of FULL field.
	UART_TXDATA_FULL     = 0x80000000 // Bit FULL.
	UART_TXDATA_DATA_Pos = 0x0        // Position of DATA field.
	UART_TXDATA_DATA_Msk = 0xff       // Bit mask of DATA field.

	// RXDATA: Receive Data Register
	UART_RXDATA_EMPTY_Pos = 0x1f       // Position of EMPTY field.
	UART_RXDATA_EMPTY_Msk = 0x80000000 // Bit mask of EMPTY field.
	UART_RXDATA_EMPTY     = 0x80000000 // Bit EMPTY.
	UART_RXDATA_DATA_Pos  = 0x0        // Position of DATA field.
	UART_RXDATA_DATA_Msk  = 0xff       // Bit mask of DATA field.

	// TXCTRL: Transmit Control Register
	UART_TXCTRL_COUNTER_Pos = 0x10    // Position of COUNTER field.
	UART_TXCTRL_COUNTER_Msk = 0x70000 // Bit mask of COUNTER field.
	UART_TXCTRL_NSTOP_Pos   = 0x1     // Position of NSTOP field.
	UART_TXCTRL_NSTOP_Msk   = 0x2     // Bit mask of NSTOP field.
	UART_TXCTRL_NSTOP       = 0x2     // Bit NSTOP.
	UART_TXCTRL_ENABLE_Pos  = 0x0     // Position of ENABLE field.
	UART_TXCTRL_ENABLE_Msk  = 0x1     // Bit mask of ENABLE field.
	UART_TXCTRL_ENABLE      = 0x1     // Bit ENABLE.

	// RXCTRL: Receive Control Register
	UART_RXCTRL_COUNTER_Pos = 0x10    // Position of COUNTER field.
	UART_RXCTRL_COUNTER_Msk = 0x70000 // Bit mask of COUNTER field.
	UART_RXCTRL_ENABLE_Pos  = 0x0     // Position of ENABLE field.
	UART_RXCTRL_ENABLE_Msk  = 0x1     // Bit mask of ENABLE field.
	UART_RXCTRL_ENABLE      = 0x1     // Bit ENABLE.

	// IE: Interrupt Enable Register
	UART_IE_RXWM_Pos = 0x1 // Position of RXWM field.
	UART_IE_RXWM_Msk = 0x2 // Bit mask of RXWM field.
	UART_IE_RXWM     = 0x2 // Bit RXWM.
	UART_IE_TXWM_Pos = 0x0 // Position of TXWM field.
	UART_IE_TXWM_Msk = 0x1 // Bit mask of TXWM field.
	UART_IE_TXWM     = 0x1 // Bit TXWM.

	// IP: Interrupt Pending Register
	UART_IP_RXWM_Pos = 0x1 // Position of RXWM field.
	UART_IP_RXWM_Msk = 0x2 // Bit mask of RXWM field.
	UART_IP_RXWM     = 0x2 // Bit RXWM.
	UART_IP_TXWM_Pos = 0x0 // Position of TXWM field.
	UART_IP_TXWM_Msk = 0x1 // Bit mask of TXWM field.
	UART_IP_TXWM     = 0x1 // Bit TXWM.

	// DIV: Baud Rate Divisor Register
	UART_DIV_VALUE_Pos = 0x0    // Position of VALUE field.
	UART_DIV_VALUE_Msk = 0xffff // Bit mask of VALUE field.
)

// Bitfields for QSPI0: Quad Serial Peripheral Interface
const (
	// DIV: Serial Clock Divisor Register
	QSPI_DIV_VALUE_Pos = 0x0   // Position of VALUE field.
	QSPI_DIV_VALUE_Msk = 0xfff // Bit mask of VALUE field.

	// MODE: Serial Clock Mode Register
	QSPI_MODE_POLARITY_Pos = 0x1 // Position of POLARITY field.
	QSPI_MODE_POLARITY_Msk = 0x2 // Bit mask of POLARITY field.
	QSPI_MODE_POLARITY     = 0x2 // Bit POLARITY.
	QSPI_MODE_PHASE_Pos    = 0x0 // Position of PHASE field.
	QSPI_MODE_PHASE_Msk    = 0x1 // Bit mask of PHASE field.
	QSPI_MODE_PHASE        = 0x1 // Bit PHASE.

	// DELAY0: Delay Control 0 Register
	QSPI_DELAY0_SCKCS_Pos = 0x10     // Position of SCKCS field.
	QSPI_DELAY0_SCKCS_Msk = 0xff0000 // Bit mask of SCKCS field.
	QSPI_DELAY0_CSSCK_Pos = 0x0      // Position of CSSCK field.
	QSPI_DELAY0_CSSCK_Msk = 0xff     // Bit mask of CSSCK field.

	// DELAY1: Delay Control 1 Register
	QSPI_DELAY1_INTERXFR_Pos = 0x10     // Position of INTERXFR field.
	QSPI_DELAY1_INTERXFR_Msk = 0xff0000 // Bit mask of INTERXFR field.
	QSPI_DELAY1_INTERCS_Pos  = 0x0      // Position of INTERCS field.
	QSPI_DELAY1_INTERCS_Msk  = 0xff     // Bit mask of INTERCS field.

	// FMT: Frame Format Register
	QSPI_FMT_LENGTH_Pos      = 0x10    // Position of LENGTH field.
	QSPI_FMT_LENGTH_Msk      = 0xf0000 // Bit mask of LENGTH field.
	QSPI_FMT_DIRECTION_Pos   = 0x3     // Position of DIRECTION field.
	QSPI_FMT_DIRECTION_Msk   = 0x8     // Bit mask of DIRECTION field.
	QSPI_FMT_DIRECTION       = 0x8     // Bit DIRECTION.
	QSPI_FMT_DIRECTION_Rx    = 0x0     //                      For dual and quad protocols, the DQ pins are tri-stated. For                     the single protocol, the DQ0 pin is driven with the transmit                     data as normal.
	QSPI_FMT_DIRECTION_Tx    = 0x1     // The receive FIFO is not populated.
	QSPI_FMT_ENDIAN_Pos      = 0x2     // Position of ENDIAN field.
	QSPI_FMT_ENDIAN_Msk      = 0x4     // Bit mask of ENDIAN field.
	QSPI_FMT_ENDIAN          = 0x4     // Bit ENDIAN.
	QSPI_FMT_ENDIAN_Big      = 0x0     // Transmit MSB first.
	QSPI_FMT_ENDIAN_Little   = 0x1     // Transmit LSB first.
	QSPI_FMT_PROTOCOL_Pos    = 0x0     // Position of PROTOCOL field.
	QSPI_FMT_PROTOCOL_Msk    = 0x3     // Bit mask of PROTOCOL field.
	QSPI_FMT_PROTOCOL_Single = 0x0     // DQ0 (MOSI), DQ1 (MISO)
	QSPI_FMT_PROTOCOL_Dual   = 0x1     // DQ0, DQ1
	QSPI_FMT_PROTOCOL_Quad   = 0x2     // DQ0, DQ1, DQ2, DQ3

	// TXDATA: Transmit Data Register
	QSPI_TXDATA_FULL_Pos = 0x1f       // Position of FULL field.
	QSPI_TXDATA_FULL_Msk = 0x80000000 // Bit mask of FULL field.
	QSPI_TXDATA_FULL     = 0x80000000 // Bit FULL.
	QSPI_TXDATA_DATA_Pos = 0x0        // Position of DATA field.
	QSPI_TXDATA_DATA_Msk = 0xff       // Bit mask of DATA field.

	// RXDATA: Receive Data Register
	QSPI_RXDATA_EMPTY_Pos = 0x1f       // Position of EMPTY field.
	QSPI_RXDATA_EMPTY_Msk = 0x80000000 // Bit mask of EMPTY field.
	QSPI_RXDATA_EMPTY     = 0x80000000 // Bit EMPTY.
	QSPI_RXDATA_DATA_Pos  = 0x0        // Position of DATA field.
	QSPI_RXDATA_DATA_Msk  = 0xff       // Bit mask of DATA field.

	// TXMARK: Transmit Watermark Register
	QSPI_TXMARK_VALUE_Pos = 0x0 // Position of VALUE field.
	QSPI_TXMARK_VALUE_Msk = 0x7 // Bit mask of VALUE field.

	// RXMARK: Receive Watermark Register
	QSPI_RXMARK_VALUE_Pos = 0x0 // Position of VALUE field.
	QSPI_RXMARK_VALUE_Msk = 0x7 // Bit mask of VALUE field.

	// FCTRL: SPI Flash Interface Control Register
	QSPI_FCTRL_ENABLE_Pos = 0x0 // Position of ENABLE field.
	QSPI_FCTRL_ENABLE_Msk = 0x1 // Bit mask of ENABLE field.
	QSPI_FCTRL_ENABLE     = 0x1 // Bit ENABLE.

	// FFMT: SPI Flash Instruction Format Register
	QSPI_FFMT_PAD_CODE_Pos      = 0x18       // Position of PAD_CODE field.
	QSPI_FFMT_PAD_CODE_Msk      = 0xff000000 // Bit mask of PAD_CODE field.
	QSPI_FFMT_CMD_CODE_Pos      = 0x10       // Position of CMD_CODE field.
	QSPI_FFMT_CMD_CODE_Msk      = 0xff0000   // Bit mask of CMD_CODE field.
	QSPI_FFMT_DATA_PROTO_Pos    = 0xc        // Position of DATA_PROTO field.
	QSPI_FFMT_DATA_PROTO_Msk    = 0x3000     // Bit mask of DATA_PROTO field.
	QSPI_FFMT_DATA_PROTO_Single = 0x0        // DQ0 (MOSI), DQ1 (MISO)
	QSPI_FFMT_DATA_PROTO_Dual   = 0x1        // DQ0, DQ1
	QSPI_FFMT_DATA_PROTO_Quad   = 0x2        // DQ0, DQ1, DQ2, DQ3
	QSPI_FFMT_ADDR_PROTO_Pos    = 0xa        // Position of ADDR_PROTO field.
	QSPI_FFMT_ADDR_PROTO_Msk    = 0xc00      // Bit mask of ADDR_PROTO field.
	QSPI_FFMT_ADDR_PROTO_Single = 0x0        // DQ0 (MOSI), DQ1 (MISO)
	QSPI_FFMT_ADDR_PROTO_Dual   = 0x1        // DQ0, DQ1
	QSPI_FFMT_ADDR_PROTO_Quad   = 0x2        // DQ0, DQ1, DQ2, DQ3
	QSPI_FFMT_CMD_PROTO_Pos     = 0x8        // Position of CMD_PROTO field.
	QSPI_FFMT_CMD_PROTO_Msk     = 0x300      // Bit mask of CMD_PROTO field.
	QSPI_FFMT_CMD_PROTO_Single  = 0x0        // DQ0 (MOSI), DQ1 (MISO)
	QSPI_FFMT_CMD_PROTO_Dual    = 0x1        // DQ0, DQ1
	QSPI_FFMT_CMD_PROTO_Quad    = 0x2        // DQ0, DQ1, DQ2, DQ3
	QSPI_FFMT_PAD_CNT_Pos       = 0x0        // Position of PAD_CNT field.
	QSPI_FFMT_PAD_CNT_Msk       = 0x1        // Bit mask of PAD_CNT field.
	QSPI_FFMT_PAD_CNT           = 0x1        // Bit PAD_CNT.
	QSPI_FFMT_ADDR_LEN_Pos      = 0x1        // Position of ADDR_LEN field.
	QSPI_FFMT_ADDR_LEN_Msk      = 0xe        // Bit mask of ADDR_LEN field.
	QSPI_FFMT_CMD_EN_Pos        = 0x0        // Position of CMD_EN field.
	QSPI_FFMT_CMD_EN_Msk        = 0x1        // Bit mask of CMD_EN field.
	QSPI_FFMT_CMD_EN            = 0x1        // Bit CMD_EN.

	// IE: SPI Interrupt Enable Register
	QSPI_IE_RXWM_Pos = 0x1 // Position of RXWM field.
	QSPI_IE_RXWM_Msk = 0x2 // Bit mask of RXWM field.
	QSPI_IE_RXWM     = 0x2 // Bit RXWM.
	QSPI_IE_TXWM_Pos = 0x0 // Position of TXWM field.
	QSPI_IE_TXWM_Msk = 0x1 // Bit mask of TXWM field.
	QSPI_IE_TXWM     = 0x1 // Bit TXWM.

	// IP: SPI Interrupt Pending Register
	QSPI_IP_RXWM_Pos = 0x1 // Position of RXWM field.
	QSPI_IP_RXWM_Msk = 0x2 // Bit mask of RXWM field.
	QSPI_IP_RXWM     = 0x2 // Bit RXWM.
	QSPI_IP_TXWM_Pos = 0x0 // Position of TXWM field.
	QSPI_IP_TXWM_Msk = 0x1 // Bit mask of TXWM field.
	QSPI_IP_TXWM     = 0x1 // Bit TXWM.
)

// Bitfields for PWM0: 8-bit timer with 4 cmp
const (
	// CFG: PWM Configuration Register
	PWM_CFG_CMP3IP_Pos     = 0x1f       // Position of CMP3IP field.
	PWM_CFG_CMP3IP_Msk     = 0x80000000 // Bit mask of CMP3IP field.
	PWM_CFG_CMP3IP         = 0x80000000 // Bit CMP3IP.
	PWM_CFG_CMP2IP_Pos     = 0x1e       // Position of CMP2IP field.
	PWM_CFG_CMP2IP_Msk     = 0x40000000 // Bit mask of CMP2IP field.
	PWM_CFG_CMP2IP         = 0x40000000 // Bit CMP2IP.
	PWM_CFG_CMP1IP_Pos     = 0x1d       // Position of CMP1IP field.
	PWM_CFG_CMP1IP_Msk     = 0x20000000 // Bit mask of CMP1IP field.
	PWM_CFG_CMP1IP         = 0x20000000 // Bit CMP1IP.
	PWM_CFG_CMP0IP_Pos     = 0x1c       // Position of CMP0IP field.
	PWM_CFG_CMP0IP_Msk     = 0x10000000 // Bit mask of CMP0IP field.
	PWM_CFG_CMP0IP         = 0x10000000 // Bit CMP0IP.
	PWM_CFG_CMP3GANG_Pos   = 0x1b       // Position of CMP3GANG field.
	PWM_CFG_CMP3GANG_Msk   = 0x8000000  // Bit mask of CMP3GANG field.
	PWM_CFG_CMP3GANG       = 0x8000000  // Bit CMP3GANG.
	PWM_CFG_CMP2GANG_Pos   = 0x1a       // Position of CMP2GANG field.
	PWM_CFG_CMP2GANG_Msk   = 0xfc000000 // Bit mask of CMP2GANG field.
	PWM_CFG_CMP1GANG_Pos   = 0x19       // Position of CMP1GANG field.
	PWM_CFG_CMP1GANG_Msk   = 0x2000000  // Bit mask of CMP1GANG field.
	PWM_CFG_CMP1GANG       = 0x2000000  // Bit CMP1GANG.
	PWM_CFG_CMP0GANG_Pos   = 0x18       // Position of CMP0GANG field.
	PWM_CFG_CMP0GANG_Msk   = 0x1000000  // Bit mask of CMP0GANG field.
	PWM_CFG_CMP0GANG       = 0x1000000  // Bit CMP0GANG.
	PWM_CFG_CMP3CENTER_Pos = 0x13       // Position of CMP3CENTER field.
	PWM_CFG_CMP3CENTER_Msk = 0x80000    // Bit mask of CMP3CENTER field.
	PWM_CFG_CMP3CENTER     = 0x80000    // Bit CMP3CENTER.
	PWM_CFG_CMP2CENTER_Pos = 0x12       // Position of CMP2CENTER field.
	PWM_CFG_CMP2CENTER_Msk = 0x40000    // Bit mask of CMP2CENTER field.
	PWM_CFG_CMP2CENTER     = 0x40000    // Bit CMP2CENTER.
	PWM_CFG_CMP1CENTER_Pos = 0x11       // Position of CMP1CENTER field.
	PWM_CFG_CMP1CENTER_Msk = 0x20000    // Bit mask of CMP1CENTER field.
	PWM_CFG_CMP1CENTER     = 0x20000    // Bit CMP1CENTER.
	PWM_CFG_CMP0CENTER_Pos = 0x10       // Position of CMP0CENTER field.
	PWM_CFG_CMP0CENTER_Msk = 0x10000    // Bit mask of CMP0CENTER field.
	PWM_CFG_CMP0CENTER     = 0x10000    // Bit CMP0CENTER.
	PWM_CFG_ENONESHOT_Pos  = 0xd        // Position of ENONESHOT field.
	PWM_CFG_ENONESHOT_Msk  = 0x2000     // Bit mask of ENONESHOT field.
	PWM_CFG_ENONESHOT      = 0x2000     // Bit ENONESHOT.
	PWM_CFG_ENALWAYS_Pos   = 0xc        // Position of ENALWAYS field.
	PWM_CFG_ENALWAYS_Msk   = 0x1000     // Bit mask of ENALWAYS field.
	PWM_CFG_ENALWAYS       = 0x1000     // Bit ENALWAYS.
	PWM_CFG_DEGLITCH_Pos   = 0xa        // Position of DEGLITCH field.
	PWM_CFG_DEGLITCH_Msk   = 0x400      // Bit mask of DEGLITCH field.
	PWM_CFG_DEGLITCH       = 0x400      // Bit DEGLITCH.
	PWM_CFG_ZEROCMP_Pos    = 0x9        // Position of ZEROCMP field.
	PWM_CFG_ZEROCMP_Msk    = 0x200      // Bit mask of ZEROCMP field.
	PWM_CFG_ZEROCMP        = 0x200      // Bit ZEROCMP.
	PWM_CFG_STICKY_Pos     = 0x8        // Position of STICKY field.
	PWM_CFG_STICKY_Msk     = 0x100      // Bit mask of STICKY field.
	PWM_CFG_STICKY         = 0x100      // Bit STICKY.
	PWM_CFG_SCALE_Pos      = 0x0        // Position of SCALE field.
	PWM_CFG_SCALE_Msk      = 0xf        // Bit mask of SCALE field.

	// CMP0: Compare Register
	PWM_CMP0_VALUE_Pos = 0x0    // Position of VALUE field.
	PWM_CMP0_VALUE_Msk = 0xffff // Bit mask of VALUE field.

	// CMP1: Compare Register
	PWM_CMP1_VALUE_Pos = 0x0    // Position of VALUE field.
	PWM_CMP1_VALUE_Msk = 0xffff // Bit mask of VALUE field.

	// CMP2: Compare Register
	PWM_CMP2_VALUE_Pos = 0x0    // Position of VALUE field.
	PWM_CMP2_VALUE_Msk = 0xffff // Bit mask of VALUE field.

	// CMP3: Compare Register
	PWM_CMP3_VALUE_Pos = 0x0    // Position of VALUE field.
	PWM_CMP3_VALUE_Msk = 0xffff // Bit mask of VALUE field.
)

// Bitfields for I2C0: Inter-Integrated Circuit Master Interface (FE310-G002 only)
const (
	// PRER_LO: Clock Prescale register lo-byte
	I2C_PRER_LO_VALUE_Pos = 0x0  // Position of VALUE field.
	I2C_PRER_LO_VALUE_Msk = 0xff // Bit mask of VALUE field.

	// PRER_HI: Clock Prescale register hi-byte
	I2C_PRER_HI_VALUE_Pos = 0x0  // Position of VALUE field.
	I2C_PRER_HI_VALUE_Msk = 0xff // Bit mask of VALUE field.

	// CTR: Control register
	I2C_CTR_EN_Pos  = 0x7  // Position of EN field.
	I2C_CTR_EN_Msk  = 0x80 // Bit mask of EN field.
	I2C_CTR_EN      = 0x80 // Bit EN.
	I2C_CTR_IEN_Pos = 0x6  // Position of IEN field.
	I2C_CTR_IEN_Msk = 0x40 // Bit mask of IEN field.
	I2C_CTR_IEN     = 0x40 // Bit IEN.

	// TXR_RXR: Transmit register / Receive register
	I2C_TXR_RXR_DATA_Pos = 0x0  // Position of DATA field.
	I2C_TXR_RXR_DATA_Msk = 0xff // Bit mask of DATA field.

	// CR: Command register
	I2C_CR_STA_Pos  = 0x7  // Position of STA field.
	I2C_CR_STA_Msk  = 0x80 // Bit mask of STA field.
	I2C_CR_STA      = 0x80 // Bit STA.
	I2C_CR_STO_Pos  = 0x6  // Position of STO field.
	I2C_CR_STO_Msk  = 0x40 // Bit mask of STO field.
	I2C_CR_STO      = 0x40 // Bit STO.
	I2C_CR_RD_Pos   = 0x5  // Position of RD field.
	I2C_CR_RD_Msk   = 0x20 // Bit mask of RD field.
	I2C_CR_RD       = 0x20 // Bit RD.
	I2C_CR_WR_Pos   = 0x4  // Position of WR field.
	I2C_CR_WR_Msk   = 0x10 // Bit mask of WR field.
	I2C_CR_WR       = 0x10 // Bit WR.
	I2C_CR_ACK_Pos  = 0x3  // Position of ACK field.
	I2C_CR_ACK_Msk  = 0x8  // Bit mask of ACK field.
	I2C_CR_ACK      = 0x8  // Bit ACK.
	I2C_CR_ACK_ACK  = 0x0
	I2C_CR_ACK_NACK = 0x1
	I2C_CR_IACK_Pos = 0x0 // Position of IACK field.
	I2C_CR_IACK_Msk = 0x1 // Bit mask of IACK field.
	I2C_CR_IACK     = 0x1 // Bit IACK.

	// SR: Status register
	I2C_SR_RX_ACK_Pos = 0x7  // Position of RX_ACK field.
	I2C_SR_RX_ACK_Msk = 0x80 // Bit mask of RX_ACK field.
	I2C_SR_RX_ACK     = 0x80 // Bit RX_ACK.
	I2C_SR_BUSY_Pos   = 0x6  // Position of BUSY field.
	I2C_SR_BUSY_Msk   = 0x40 // Bit mask of BUSY field.
	I2C_SR_BUSY       = 0x40 // Bit BUSY.
	I2C_SR_AL_Pos     = 0x5  // Position of AL field.
	I2C_SR_AL_Msk     = 0x20 // Bit mask of AL field.
	I2C_SR_AL         = 0x20 // Bit AL.
	I2C_SR_TIP_Pos    = 0x1  // Position of TIP field.
	I2C_SR_TIP_Msk    = 0x2  // Bit mask of TIP field.
	I2C_SR_TIP        = 0x2  // Bit TIP.
	I2C_SR_IF_Pos     = 0x0  // Position of IF field.
	I2C_SR_IF_Msk     = 0x1  // Bit mask of IF field.
	I2C_SR_IF         = 0x1  // Bit IF.
)
