// Automatically generated file. DO NOT EDIT.
// Generated by gen-device-svd.go from STM32F3x8.svd, see https://github.com/posborne/cmsis-svd/tree/master/data/STMicro

// STM32F3x8
//


.syntax unified

// This is the default handler for interrupts, if triggered but not defined.
.section .text.Default_Handler
.global  Default_Handler
.type    Default_Handler, %function
Default_Handler:
    wfe
    b    Default_Handler
.size Default_Handler, .-Default_Handler

// Avoid the need for repeated .weak and .set instructions.
.macro IRQ handler
    .weak  \handler
    .set   \handler, Default_Handler
.endm

// Must set the "a" flag on the section:
// https://svnweb.freebsd.org/base/stable/11/sys/arm/arm/locore-v4.S?r1=321049&r2=321048&pathrev=321049
// https://sourceware.org/binutils/docs/as/Section.html#ELF-Version
.section .isr_vector, "a", %progbits
.global  __isr_vector
    // Interrupt vector as defined by Cortex-M, starting with the stack top.
    // On reset, SP is initialized with *0x0 and PC is loaded with *0x4, loading
    // _stack_top and Reset_Handler.
    .long _stack_top
    .long Reset_Handler
    .long NMI_Handler
    .long HardFault_Handler
    .long MemoryManagement_Handler
    .long BusFault_Handler
    .long UsageFault_Handler
    .long 0
    .long 0
    .long 0
    .long 0
    .long SVC_Handler
    .long DebugMon_Handler
    .long 0
    .long PendSV_Handler
    .long SysTick_Handler

    // Extra interrupts for peripherals defined by the hardware vendor.
    .long WWDG_IRQ_IRQHandler
    .long PVD_IRQ_IRQHandler
    .long TAMP_STAMP_IRQHandler
    .long RTC_WKUP_IRQHandler
    .long FLASH_IRQ_IRQHandler
    .long RCC_IRQ_IRQHandler
    .long EXTI0_IRQHandler
    .long EXTI1_IRQHandler
    .long EXTI2_TSC_IRQHandler
    .long EXTI3_IRQHandler
    .long EXTI4_IRQHandler
    .long DMA1_CH1_IRQ_IRQHandler
    .long DMA1_CH2_IRQ_IRQHandler
    .long DMA1_CH3_IRQ_IRQHandler
    .long DMA1_CH4_IRQ_IRQHandler
    .long DMA1_CH5_IRQ_IRQHandler
    .long DMA1_CH6_IRQ_IRQHandler
    .long DMA1_CH7_IRQ_IRQHandler
    .long ADC1_IRQ_IRQHandler
    .long CAN_TX_IRQ_IRQHandler
    .long CAN_RXD_IRQ_IRQHandler
    .long CAN_RXI_IRQ_IRQHandler
    .long CAN_SCE_IRQ_IRQHandler
    .long EXTI9_5_IRQHandler
    .long TIM15_IRQ_IRQHandler
    .long TIM16_IRQ_IRQHandler
    .long TIM17_IRQ_IRQHandler
    .long TIM18_DAC3_IRQ_IRQHandler
    .long TIM2_IRQ_IRQHandler
    .long TIM3_IRQ_IRQHandler
    .long TIM4_IRQ_IRQHandler
    .long I2C1_EV_IRQ_IRQHandler
    .long I2C1_ER_IRQ_IRQHandler
    .long I2C2_EV_IRQ_IRQHandler
    .long I2C2_ER_IRQ_IRQHandler
    .long SPI1_IRQ_IRQHandler
    .long SPI2_IRQ_IRQHandler
    .long USART1_IRQ_IRQHandler
    .long USART2_IRQ_IRQHandler
    .long USART3_IRQ_IRQHandler
    .long EXTI15_10_IRQ_IRQHandler
    .long RTC_ALARM_IT_IRQ_IRQHandler
    .long 0
    .long TIM12_IRQ_IRQHandler
    .long TIM13_IRQ_IRQHandler
    .long TIM14_IRQ_IRQHandler
    .long TIM8_CC_IRQHandler
    .long ADC3_IRQHandler
    .long FMC_IRQHandler
    .long 0
    .long TIM5_IRQ_IRQHandler
    .long SPI3_IRQ_IRQHandler
    .long UART4_EXTI34_IRQHandler
    .long UART5_EXTI35_IRQHandler
    .long TIM6_DAC1_IRQHandler
    .long TIM7_IRQ_IRQHandler
    .long DMA2_Channel1_IRQHandler
    .long DMA2_Channel2_IRQHandler
    .long DMA2_Channel3_IRQHandler
    .long DMA2_Channel4_IRQHandler
    .long DMA2_Channel5_IRQHandler
    .long ADC_SD1_IRQ_IRQHandler
    .long ADC_SD2_IRQ_IRQHandler
    .long ADC_SD3_IRQ_IRQHandler
    .long 0
    .long 0
    .long COMP7_IRQHandler
    .long 0
    .long 0
    .long 0
    .long 0
    .long 0
    .long I2C3_EV_IRQHandler
    .long I2C3_ER_IRQHandler
    .long USB_HP_IRQ_IRQHandler
    .long USB_LP_IRQ_IRQHandler
    .long USB_WAKEUP_IRQ_IRQHandler
    .long TIM20_BRK_IRQHandler
    .long TIM19_IRQ_IRQHandler
    .long TIM20_TRG_COM_IRQHandler
    .long TIM20_CC_IRQHandler
    .long FPU_IRQHandler

    // Define default implementations for interrupts, redirecting to
    // Default_Handler when not implemented.
    IRQ NMI_Handler
    IRQ HardFault_Handler
    IRQ MemoryManagement_Handler
    IRQ BusFault_Handler
    IRQ UsageFault_Handler
    IRQ SVC_Handler
    IRQ DebugMon_Handler
    IRQ PendSV_Handler
    IRQ SysTick_Handler
    IRQ WWDG_IRQ_IRQHandler
    IRQ PVD_IRQ_IRQHandler
    IRQ TAMP_STAMP_IRQHandler
    IRQ RTC_WKUP_IRQHandler
    IRQ FLASH_IRQ_IRQHandler
    IRQ RCC_IRQ_IRQHandler
    IRQ EXTI0_IRQHandler
    IRQ EXTI1_IRQHandler
    IRQ EXTI2_TSC_IRQHandler
    IRQ EXTI3_IRQHandler
    IRQ EXTI4_IRQHandler
    IRQ DMA1_CH1_IRQ_IRQHandler
    IRQ DMA1_CH2_IRQ_IRQHandler
    IRQ DMA1_CH3_IRQ_IRQHandler
    IRQ DMA1_CH4_IRQ_IRQHandler
    IRQ DMA1_CH5_IRQ_IRQHandler
    IRQ DMA1_CH6_IRQ_IRQHandler
    IRQ DMA1_CH7_IRQ_IRQHandler
    IRQ ADC1_IRQ_IRQHandler
    IRQ CAN_TX_IRQ_IRQHandler
    IRQ CAN_RXD_IRQ_IRQHandler
    IRQ CAN_RXI_IRQ_IRQHandler
    IRQ CAN_SCE_IRQ_IRQHandler
    IRQ EXTI9_5_IRQHandler
    IRQ TIM15_IRQ_IRQHandler
    IRQ TIM16_IRQ_IRQHandler
    IRQ TIM17_IRQ_IRQHandler
    IRQ TIM18_DAC3_IRQ_IRQHandler
    IRQ TIM2_IRQ_IRQHandler
    IRQ TIM3_IRQ_IRQHandler
    IRQ TIM4_IRQ_IRQHandler
    IRQ I2C1_EV_IRQ_IRQHandler
    IRQ I2C1_ER_IRQ_IRQHandler
    IRQ I2C2_EV_IRQ_IRQHandler
    IRQ I2C2_ER_IRQ_IRQHandler
    IRQ SPI1_IRQ_IRQHandler
    IRQ SPI2_IRQ_IRQHandler
    IRQ USART1_IRQ_IRQHandler
    IRQ USART2_IRQ_IRQHandler
    IRQ USART3_IRQ_IRQHandler
    IRQ EXTI15_10_IRQ_IRQHandler
    IRQ RTC_ALARM_IT_IRQ_IRQHandler
    IRQ TIM12_IRQ_IRQHandler
    IRQ TIM13_IRQ_IRQHandler
    IRQ TIM14_IRQ_IRQHandler
    IRQ TIM8_CC_IRQHandler
    IRQ ADC3_IRQHandler
    IRQ FMC_IRQHandler
    IRQ TIM5_IRQ_IRQHandler
    IRQ SPI3_IRQ_IRQHandler
    IRQ UART4_EXTI34_IRQHandler
    IRQ UART5_EXTI35_IRQHandler
    IRQ TIM6_DAC1_IRQHandler
    IRQ TIM7_IRQ_IRQHandler
    IRQ DMA2_Channel1_IRQHandler
    IRQ DMA2_Channel2_IRQHandler
    IRQ DMA2_Channel3_IRQHandler
    IRQ DMA2_Channel4_IRQHandler
    IRQ DMA2_Channel5_IRQHandler
    IRQ ADC_SD1_IRQ_IRQHandler
    IRQ ADC_SD2_IRQ_IRQHandler
    IRQ ADC_SD3_IRQ_IRQHandler
    IRQ COMP7_IRQHandler
    IRQ I2C3_EV_IRQHandler
    IRQ I2C3_ER_IRQHandler
    IRQ USB_HP_IRQ_IRQHandler
    IRQ USB_LP_IRQ_IRQHandler
    IRQ USB_WAKEUP_IRQ_IRQHandler
    IRQ TIM20_BRK_IRQHandler
    IRQ TIM19_IRQ_IRQHandler
    IRQ TIM20_TRG_COM_IRQHandler
    IRQ TIM20_CC_IRQHandler
    IRQ FPU_IRQHandler
