// Automatically generated file. DO NOT EDIT.
// Generated by gen-device-svd.go from STM32L562.svd, see https://github.com/posborne/cmsis-svd/tree/master/data/STMicro

// STM32L562
//


.syntax unified

// This is the default handler for interrupts, if triggered but not defined.
.section .text.Default_Handler
.global  Default_Handler
.type    Default_Handler, %function
Default_Handler:
    wfe
    b    Default_Handler
.size Default_Handler, .-Default_Handler

// Avoid the need for repeated .weak and .set instructions.
.macro IRQ handler
    .weak  \handler
    .set   \handler, Default_Handler
.endm

// Must set the "a" flag on the section:
// https://svnweb.freebsd.org/base/stable/11/sys/arm/arm/locore-v4.S?r1=321049&r2=321048&pathrev=321049
// https://sourceware.org/binutils/docs/as/Section.html#ELF-Version
.section .isr_vector, "a", %progbits
.global  __isr_vector
    // Interrupt vector as defined by Cortex-M, starting with the stack top.
    // On reset, SP is initialized with *0x0 and PC is loaded with *0x4, loading
    // _stack_top and Reset_Handler.
    .long _stack_top
    .long Reset_Handler
    .long NMI_Handler
    .long HardFault_Handler
    .long MemoryManagement_Handler
    .long BusFault_Handler
    .long UsageFault_Handler
    .long 0
    .long 0
    .long 0
    .long 0
    .long SVC_Handler
    .long DebugMon_Handler
    .long 0
    .long PendSV_Handler
    .long SysTick_Handler

    // Extra interrupts for peripherals defined by the hardware vendor.
    .long WWDG_IRQHandler
    .long PVD_PVM_IRQHandler
    .long RTC_IRQHandler
    .long RTC_S_IRQHandler
    .long TAMP_IRQHandler
    .long TAMP_S_IRQHandler
    .long FLASH_IRQHandler
    .long FLASH_S_IRQHandler
    .long 0
    .long RCC_IRQHandler
    .long RCC_S_IRQHandler
    .long EXTI0_IRQHandler
    .long EXTI1_IRQHandler
    .long EXTI2_IRQHandler
    .long EXTI3_IRQHandler
    .long EXTI4_IRQHandler
    .long EXTI5_IRQHandler
    .long EXTI6_IRQHandler
    .long EXTI7_IRQHandler
    .long EXTI8_IRQHandler
    .long EXTI9_IRQHandler
    .long EXTI10_IRQHandler
    .long EXTI11_IRQHandler
    .long EXTI12_IRQHandler
    .long EXTI13_IRQHandler
    .long EXTI14_IRQHandler
    .long EXTI15_IRQHandler
    .long DMAMUX1_OVR_IRQHandler
    .long DMAMUX1_OVR_S_IRQHandler
    .long DMA1_Channel1_IRQHandler
    .long DMA1_Channel2_IRQHandler
    .long DMA1_Channel3_IRQHandler
    .long DMA1_Channel4_IRQHandler
    .long DMA1_Channel5_IRQHandler
    .long DMA1_Channel6_IRQHandler
    .long DMA1_Channel7_IRQHandler
    .long DMA1_Channel8_IRQHandler
    .long ADC1_2_IRQHandler
    .long 0
    .long FDCAN1_IT0_IRQHandler
    .long FDCAN1_IT1_IRQHandler
    .long TIM1_BRK_IRQHandler
    .long TIM1_UP_IRQHandler
    .long TIM1_TRG_COM_IRQHandler
    .long TIM1_CC_IRQHandler
    .long TIM2_IRQHandler
    .long TIM2_3_IRQHandler
    .long TIM2_4_IRQHandler
    .long TIM2_5_IRQHandler
    .long 0
    .long 0
    .long TIM8_BRK_IRQHandler
    .long TIM8_UP_IRQHandler
    .long TIM8_TRG_COM_IRQHandler
    .long TIM8_CC_IRQHandler
    .long I2C1_EV_IRQHandler
    .long I2C1_ER_IRQHandler
    .long I2C2_EV_IRQHandler
    .long I2C2_ER_IRQHandler
    .long SPI1_IRQHandler
    .long SPI2_IRQHandler
    .long USART1_IRQHandler
    .long USART2_IRQHandler
    .long USART3_IRQHandler
    .long UART4_IRQHandler
    .long UART5_IRQHandler
    .long LPUART1_IRQHandler
    .long LPTIM1_IRQHandler
    .long LPTIM2_IRQHandler
    .long TIM15_IRQHandler
    .long TIM16_IRQHandler
    .long TIM17_IRQHandler
    .long COMP_IRQHandler
    .long USB_FS_IRQHandler
    .long 0
    .long FMC_IRQHandler
    .long OCTOSPI1_IRQHandler
    .long 0
    .long SDMMC1_IRQHandler
    .long 0
    .long DMA2_CH1_IRQHandler
    .long DMA2_CH2_IRQHandler
    .long DMA2_CH3_IRQHandler
    .long DMA2_CH4_IRQHandler
    .long DMA2_CH5_IRQHandler
    .long DMA2_CH6_IRQHandler
    .long DMA2_CH7_IRQHandler
    .long DMA2_CH8_IRQHandler
    .long I2C3_EV_IRQHandler
    .long I2C3_ER_IRQHandler
    .long SAI1_IRQHandler
    .long SAI2_IRQHandler
    .long TSC_IRQHandler
    .long AES_IRQHandler
    .long RNG_IRQHandler
    .long 0
    .long 0
    .long PKA_IRQHandler
    .long LPTIM3_IRQHandler
    .long SPI3_IRQHandler
    .long I2C4_ER_IRQHandler
    .long I2C4_EV_IRQHandler
    .long DFSDM1_FLT0_IRQHandler
    .long DFSDM1_FLT1_IRQHandler
    .long DFSDM1_FLT2_IRQHandler
    .long DFSDM1_FLT3_IRQHandler
    .long UCPD1_IRQHandler
    .long ICACHE_IRQHandler
    .long OTFDEC1_IRQHandler

    // Define default implementations for interrupts, redirecting to
    // Default_Handler when not implemented.
    IRQ NMI_Handler
    IRQ HardFault_Handler
    IRQ MemoryManagement_Handler
    IRQ BusFault_Handler
    IRQ UsageFault_Handler
    IRQ SVC_Handler
    IRQ DebugMon_Handler
    IRQ PendSV_Handler
    IRQ SysTick_Handler
    IRQ WWDG_IRQHandler
    IRQ PVD_PVM_IRQHandler
    IRQ RTC_IRQHandler
    IRQ RTC_S_IRQHandler
    IRQ TAMP_IRQHandler
    IRQ TAMP_S_IRQHandler
    IRQ FLASH_IRQHandler
    IRQ FLASH_S_IRQHandler
    IRQ RCC_IRQHandler
    IRQ RCC_S_IRQHandler
    IRQ EXTI0_IRQHandler
    IRQ EXTI1_IRQHandler
    IRQ EXTI2_IRQHandler
    IRQ EXTI3_IRQHandler
    IRQ EXTI4_IRQHandler
    IRQ EXTI5_IRQHandler
    IRQ EXTI6_IRQHandler
    IRQ EXTI7_IRQHandler
    IRQ EXTI8_IRQHandler
    IRQ EXTI9_IRQHandler
    IRQ EXTI10_IRQHandler
    IRQ EXTI11_IRQHandler
    IRQ EXTI12_IRQHandler
    IRQ EXTI13_IRQHandler
    IRQ EXTI14_IRQHandler
    IRQ EXTI15_IRQHandler
    IRQ DMAMUX1_OVR_IRQHandler
    IRQ DMAMUX1_OVR_S_IRQHandler
    IRQ DMA1_Channel1_IRQHandler
    IRQ DMA1_Channel2_IRQHandler
    IRQ DMA1_Channel3_IRQHandler
    IRQ DMA1_Channel4_IRQHandler
    IRQ DMA1_Channel5_IRQHandler
    IRQ DMA1_Channel6_IRQHandler
    IRQ DMA1_Channel7_IRQHandler
    IRQ DMA1_Channel8_IRQHandler
    IRQ ADC1_2_IRQHandler
    IRQ FDCAN1_IT0_IRQHandler
    IRQ FDCAN1_IT1_IRQHandler
    IRQ TIM1_BRK_IRQHandler
    IRQ TIM1_UP_IRQHandler
    IRQ TIM1_TRG_COM_IRQHandler
    IRQ TIM1_CC_IRQHandler
    IRQ TIM2_IRQHandler
    IRQ TIM2_3_IRQHandler
    IRQ TIM2_4_IRQHandler
    IRQ TIM2_5_IRQHandler
    IRQ TIM8_BRK_IRQHandler
    IRQ TIM8_UP_IRQHandler
    IRQ TIM8_TRG_COM_IRQHandler
    IRQ TIM8_CC_IRQHandler
    IRQ I2C1_EV_IRQHandler
    IRQ I2C1_ER_IRQHandler
    IRQ I2C2_EV_IRQHandler
    IRQ I2C2_ER_IRQHandler
    IRQ SPI1_IRQHandler
    IRQ SPI2_IRQHandler
    IRQ USART1_IRQHandler
    IRQ USART2_IRQHandler
    IRQ USART3_IRQHandler
    IRQ UART4_IRQHandler
    IRQ UART5_IRQHandler
    IRQ LPUART1_IRQHandler
    IRQ LPTIM1_IRQHandler
    IRQ LPTIM2_IRQHandler
    IRQ TIM15_IRQHandler
    IRQ TIM16_IRQHandler
    IRQ TIM17_IRQHandler
    IRQ COMP_IRQHandler
    IRQ USB_FS_IRQHandler
    IRQ FMC_IRQHandler
    IRQ OCTOSPI1_IRQHandler
    IRQ SDMMC1_IRQHandler
    IRQ DMA2_CH1_IRQHandler
    IRQ DMA2_CH2_IRQHandler
    IRQ DMA2_CH3_IRQHandler
    IRQ DMA2_CH4_IRQHandler
    IRQ DMA2_CH5_IRQHandler
    IRQ DMA2_CH6_IRQHandler
    IRQ DMA2_CH7_IRQHandler
    IRQ DMA2_CH8_IRQHandler
    IRQ I2C3_EV_IRQHandler
    IRQ I2C3_ER_IRQHandler
    IRQ SAI1_IRQHandler
    IRQ SAI2_IRQHandler
    IRQ TSC_IRQHandler
    IRQ AES_IRQHandler
    IRQ RNG_IRQHandler
    IRQ PKA_IRQHandler
    IRQ LPTIM3_IRQHandler
    IRQ SPI3_IRQHandler
    IRQ I2C4_ER_IRQHandler
    IRQ I2C4_EV_IRQHandler
    IRQ DFSDM1_FLT0_IRQHandler
    IRQ DFSDM1_FLT1_IRQHandler
    IRQ DFSDM1_FLT2_IRQHandler
    IRQ DFSDM1_FLT3_IRQHandler
    IRQ UCPD1_IRQHandler
    IRQ ICACHE_IRQHandler
    IRQ OTFDEC1_IRQHandler
